from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.agenda.models import Agenda, AgendaCategory

@login_required
def object_list(request, model, filter_cnd={}, order_by='-date_create', search_params={}, form=None, **kw):
    if model == 'agenda':
        queryset = Agenda.objects.all()
    if model == 'agendacategory':
        queryset = AgendaCategory.objects.all()

    return generic.jobject_list(request, queryset, model, form, filter_cnd, order_by, **kw)

@login_required
def add(request, model=None, **kw):
    return generic.create_object(request, model, **kw)

@login_required
def object_detail(request, model, object_id):
    return generic.object_detail(request, model, object_id)

@login_required
def update(request, model=None, **kw):
    kw['extra_context'] = {'mode' : 'update'}
    return generic.update_object(request, model, ext="_update", **kw)
