var NUM_PER_PAGE = 100;
var grid_giorni;
    
Ext.onReady(function(){   
    if (giorno != '') {
        if (giorno == 'oggi') {
            d = new Date();
            g = d.getDate() >= 10 ? d.getDate() : '0'+d.getDate();
            m = (d.getMonth() + 1) >= 10 ? (d.getMonth() + 1) : '0'+ (d.getMonth() + 1)
            data = g + '/' + m + '/' + d.getFullYear(); 
            document.getElementById('id_calldate').value = data;
        }

    }
    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   

    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/asterisk/cdr/ajax/list',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [      
            {name: 'id'},
            {name: 'calldate'},
            {name: 'calldate_for_group'},
            {name: 'src'},
            {name: 'dst'},           
            {name: 'dcontext'},
            {name: 'duration'},
            {name: 'billsec'},
            {name: 'disposition'}
            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Data", width: 15, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y H:i'),
        	dataIndex: "calldate"},
        {header: "Data", width: 1, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y'),
        	dataIndex: "calldate_for_group", hidden:true},            
        {header: "Effettuata da", width: 15, dataIndex: "src"},
        {header: "Numero chiamato", width: 15, dataIndex: "dst"},
        {header: "Contesto", width: 10, dataIndex: "dcontext"},
        {header: "Durata Tot.", width: 10, dataIndex: "duration"},
        {header: "Durata Chiamata", width: 10, dataIndex: "billsec"},
        {header: "Disposition", width: 10, dataIndex: "disposition"},
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'calldate_for_group',
        remoteGroup: true
    });

    ds.setDefaultSort('calldate', 'DESC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Chiamate {0} - {1} di {2}',
        emptyMsg: "Nessuna chiamata da visualizzare"
    });
    
    grid_giorni = new Ext.grid.GridPanel({
        el:'grid_chiamate',
        title:'Lista Chiamate',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),
                
        bbar: bbar,
        plugins: new Ext.grid.GroupSummary()
    });
    
    grid_giorni.render();
	    
    // trigger the data store load
    //ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    ext_search = new ExtSearch({'url':'/asterisk/cdr/ajax/list',
                               'grid':grid_giorni,
                               'button_id':'cerca'});    
    ext_search.search();
});