var NUM_PER_PAGE = 100;
var grid_rec;
    
Ext.onReady(function(){       
    /***********************
     * RENDER FUNCTIONS
     ***********************/
    
    function renderDownload(value, p, record){
        if (record.data.recall != '')
            return String.format("<a href='/asterisk/record/download/"+record.id+"/'><img src='/static/img/icon_download.png' title=\"Scarica Registrazione\" /></a>");
    }

    function renderDelete(value, p, record){
        if (record.data.recall != '')        
            return String.format("<a href='#' onclick='confermaEliminaRegistrazione("+record.id+")'><img src='/static/img/icon_delete.png' title=\"Elimina Registrazione\" /></a>");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/asterisk/record/ajax/list',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [      
            {name: 'id'},
            {name: 'ts'},
            {name: 'ts_for_group'},            
            {name: 'caller'},
            {name: 'callee'},
            {name: 'recin'},           
            {name: 'recout'},
            {name: 'recall'},
            {name: 'download'},
            {name: 'delete'}            
            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Data", width: 20, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y H:i'),
        	dataIndex: "ts"},
        {header: "Data", width: 1, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y'),
        	dataIndex: "ts_for_group", hidden:true},                        
        {header: "Effettuata da", width: 20, dataIndex: "caller"},
        {header: "Numero chiamato", width: 20, dataIndex: "callee"},
        {header: "Registrazione", width: 40, dataIndex: "recall"},
        {header: "Download", width: 10, align:"center", renderer: renderDownload, 
            dataIndex: 'download', menuDisabled: true, sortable: false, resizable : false, groupable: false},
        {header: "Cancella", width: 10, align:"center", renderer: renderDelete, 
            dataIndex: 'delete', menuDisabled: true, sortable: false, resizable : false, groupable: false}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'ts_for_group',
        remoteGroup: true
    });

    ds.setDefaultSort('ts', 'DESC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Registrazioni {0} - {1} di {2}',
        emptyMsg: "Nessuna registrazione da visualizzare"
    });
    
    grid_rec = new Ext.grid.GridPanel({
        el:'grid_registrazioni',
        title:'Lista Registrazioni',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),
                
        bbar: bbar,
        plugins: new Ext.grid.GroupSummary()
    });
    
    grid_rec.render();
	    
    // trigger the data store load
    //ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    ext_search = new ExtSearch({'url':'/asterisk/record/ajax/list',
                               'grid':grid_rec,
                               'button_id':'cerca'});    
    ext_search.search();
});

function confermaEliminaRegistrazione(id_registrazione){
    ext_confirm = new ExtConfirm({
                        'url': '/asterisk/record/delete/' + id_registrazione,
                        'msgConfirm': "Sei sicuro di voler procedere con la cancellazione della registrazione? Questo comportera' l'eliminazione del file anche dal disco rigido. Continuare?",
                        'progressText': "Cancellazione in corso. Attendere..",
                        'success_msg' : "La registrazione e' stata cancellata correttamente",
                        'post_confirm' : reload_grid
                 });
    ext_confirm.show();
}

function reload_grid() {
    grid_rec.getStore().reload();
}