var NUM_PER_PAGE = 100;
var grid_giorni;
var sf;
Ext.onReady(function(){
    // turn on validation errors beside the field globally
    Ext.form.Field.prototype.msgTarget = 'side';
        
    sf = new Ext.form.FormPanel({
        labelWidth: 150, // label settings here cascade unless overridden
        frame:true,
        title: 'Effettua una chiamata',
        bodyStyle:'padding:5px 5px 0',
        width: 380,
        defaults: {width: 180},
        defaultType: 'textfield',
        waitMsgTarget: true,
        
        items: [{
                fieldLabel: 'Numero da chiamare',
                name: 'numero',
                allowBlank:false
            }
        ],

        buttons: [{
            text: 'Chiama',
            handler: confirm_chiamata
            }]
    });

    sf.render("click");
                                                
    //var b_chiama = new Ext.Button({renderTo:'click',text:'Chiama Numero'});
    //b_chiama.on('click', confirm_chiamata);    
});


function confirm_chiamata() {           
	// Show a dialog using config options:
	Ext.Msg.show({
	   title:'Attenzione?',
	   msg: 'Sei sicuro di voler chiamare il numero?',
	   buttons: Ext.Msg.YESNOCANCEL,
	   fn: processChiamata,
	   icon: Ext.MessageBox.QUESTION
	});	
}

function processChiamata(answer){
	if (answer=='yes') {
		Ext.MessageBox.show({
			msg: 'Attendere prego...',
			progressText: 'Chiamata in corso...',
			width: 300,
			wait: true,
			waitConfig: {
				interval: 200
			}
		});
        
		// Call to reload squid
		Ext.Ajax.request({
			url: '/asterisk/cick_to_call',
            method: "POST",
            params: {'numero': sf.getForm().getValues().numero},
			success: f_successChiamata,
			failure: f_failure
		});		
	}	
}

function f_successChiamata(result){
	if (result.responseText == 'OK') {
		var title = 'OK!';
		var msg = "Operazione avvenuta con successo.";
		var icon = Ext.MessageBox.INFO;
	}
	else {
		var title = 'ERRORE!';
		var msg = result.responseText;
		var icon = Ext.MessageBox.ERROR;	
	}

	Ext.Msg.show({
		title: title,
		width: 400,
		msg: msg,
		buttons: Ext.Msg.OK,
		icon: icon
	});
}

function f_failure(result){
	Ext.Msg.show({
	   title:'ERRORE!',
	   width: 400,
	   msg: "C'e' stato un errore mentre si effetuava la chiamata. Contattare l'amministratore.",
	   buttons: Ext.Msg.OK,
	   icon: Ext.MessageBox.ERROR
	});
}