from django.contrib.comments.models import *

DCONTEXT = (
    ('check-password', 'check password'),
    ('default', 'default'),
    ('from-gsm', 'from GSM'),
    ('from-internal', 'INTERNA'),
    ('from-pstn', 'ESTERNA'),
)

LAST_APP = (
    ('Dial', 'Dial'),
    ('Echo', 'Echo'),
    ('Goto', 'Go to'),
    ('GotoIf', 'Go to if'),
    ('GotoIfTime', 'Go to if time'),
    ('Hangup', 'Hangup'),
    ('Playback', 'Playback'),
    ('PlayTones', 'Play tones'),
)

DISPOSITION = (
    (0, ''),
    (1, ''),
    (2, ''),
    (4, ''),
    (8, ''),
)

AMAFLAGS = (
    (3, ''),
)
class cdr (models.Model):
    calldate = models.DateTimeField(
    )
    clid = models.CharField(
        max_length = 80,
        verbose_name = 'chiamante',
        help_text = 'Caller*ID with text',
    )
    src = models.CharField(
        max_length = 80,
        verbose_name = 'numero chiamante',
        help_text = 'Caller*ID number',
    )
    dst = models.CharField(
        max_length = 80,
        verbose_name = 'numero chiamato',
        help_text = 'Destination extension',
    )
    dcontext = models.CharField(
        max_length = 80,
        choices = DCONTEXT,
        verbose_name = 'contesto',
        help_text = 'Destination context',
    )
    channel = models.CharField(
        max_length = 80,
        verbose_name = 'canale sorgente',
        help_text = 'Channel used',
    )
    dstchannel = models.CharField(
        max_length = 80,
        verbose_name = 'canale destinazione',
        help_text = 'Destination channel if appropriate',
    )
    lastapp = models.CharField(
        max_length = 80,
        choices = LAST_APP,
        verbose_name = 'last application',
        help_text = 'Last application if appropriate',
    )
    lastdata = models.CharField(
        max_length = 80,
        verbose_name = 'last application data',
        help_text = 'Last application data (arguments)',
    )
    duration = models.IntegerField(
        verbose_name = 'durata totale',
        help_text = 'Total time in system, in seconds',
    )
    billsec = models.IntegerField(
        verbose_name = 'durata chiamata',
        help_text = 'Total time call is up, in seconds',
    )
    disposition = models.CharField(
        max_length = 80,
        choices = DISPOSITION,
        verbose_name = 'stato',
        help_text = 'What happened to the call: ANSWERED, NO ANSWER, BUSY, FAILED',
    )
    amaflags = models.IntegerField(
        choices = AMAFLAGS,
        verbose_name = '',
        help_text = '',
    )
    accountcode = models.CharField(
        max_length = 20,
        verbose_name = '',
        help_text = '',
    )
    uniqueid = models.CharField(
        max_length = 40,
        verbose_name = '',
        help_text = '',
    )
    userfield = models.CharField(
        max_length = 255,
        verbose_name = '',
        help_text = '',
    )

    class Admin:
        pass

    class Meta:
        verbose_name = "Telefonata"
        verbose_name_plural = "Telefonate"
        db_table = "asterisk_cdr"


class Record (models.Model):
    record = models.AutoField(primary_key=True)
    ts = models.DateTimeField(
    )
    
    caller = models.CharField(
        max_length = 80,
        verbose_name = 'chiamante',
        #help_text = 'Chiamante',
    )
    callee = models.CharField(
        max_length = 80,
        verbose_name = 'numero chiamante',
        #help_text = 'Caller*ID number',
    )
    recin = models.CharField(
        max_length = 200,
        verbose_name = 'registrazione ingresso',
        #help_text = 'Registrazione in Ingresso',
    )
    recout = models.CharField(
        max_length = 200,
        verbose_name = 'registrazione uscita',
        #help_text = 'Registrazione in Uscita',
    )
    recall = models.CharField(
        max_length = 200,
        verbose_name = 'registrazione completa',
        #help_text = 'Registrazione Completa',
    )
    
    class Admin:
        pass

    class Meta:
        verbose_name = "Registrazione"
        verbose_name_plural = "Registrazioni"
        db_table = "records"
        permissions = (
            ("can_list_record", "Can list records"),
            ("can_download_record", "Can download records"),
            ("can_delete_record", "Can delete records"),
        )