from django.views.generic.list_detail import object_list
from django.views.generic.create_update import create_object, update_object
from django.views.generic.date_based import archive_year, archive_month, archive_day
from django.shortcuts import render_to_response, get_object_or_404
from django import forms as forms_django

from jungle.agenda.models import Agenda, AgendaCategory

# Create your views here.

def call(request, mode, page=None, object_id=None, year=None, month=None, day=None):
    kw = {
        'extra_context' : {'path': request.path, 'mode' :  mode,},
    }
    if mode == 'list':
        queryset = call.objects.all()
        paginate_by = 2
        kw['template_name'] = 'call_list.tmpl'
        return object_list(request, queryset, paginate_by, page, **kw)

    if mode == 'add':
        model = call
        return create_object (request, model, **kw)

    if mode == 'edit':
        model = call
        return update_object (request, model, object_id, **kw)

    if mode == 'date':
        queryset = call.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list, **kw)

    #if mode == 'search' && request.method == 'POST':
        #model = call
        #paginate_by = 2
        #return render_to_response

def call_category(request, mode, page=None, object_id=None):
    if mode == 'list':
        queryset = CallCategory.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if mode == 'add':
        model = CallCategory
        return create_object (request, model)
    if mode == 'edit':
        model = CallCategory
        return update_object (request, model, object_id)
