<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it" lang="it">

  <head>

    <%def name="title()">Thunder</%def>
    <title>${self.title()}</title>

   <%def name="css_layout()"></%def>

   <%def name="css()">
        <link rel="stylesheet"  href="/media/css/global.css" type="text/css" />
        <link rel="stylesheet"  href="/media/css/widgets.css" type="text/css" />
        <link rel="stylesheet" type="text/css" href="/static/js/extjs/resources/css/ext-all.css" />
        <link rel="stylesheet" type="text/css" href="/static/js/extjs/resources/css/xtheme-gray.css" />
        <link href="/static/css/main.css" rel="stylesheet" type="text/css" media="screen" />
   </%def> ${self.css()}

   <%def name="meta()">
     <meta http-equiv="Content-type" content="text/html; charset=utf-8" />
     <meta http-equiv="Content-Language" content="it-it" />
     <link  rel="shortcut icon" href="/static/img/favicon.ico" />
   </%def> ${self.meta()}

<%def name="js()">
  <script type="text/javascript" src="/jsi18n/"></script>  
  <script type="text/javascript" src="/media/js/core.js"></script>
  <script type="text/javascript" src="/media/js/admin/RelatedObjectLookups.js"></script>
  <script type="text/javascript" src="/media/js/calendar.js"></script>
  <script type="text/javascript" src="/media/js/admin/DateTimeShortcuts.js"></script>
  <script type="text/javascript" src="/media/js/SelectBox.js"></script>
  <script type="text/javascript" src="/media/js/SelectFilter2.js"></script>
  <script type="text/javascript" src="/static/js/extjs/adapter/ext/ext-base.js"></script>
  <script type="text/javascript" src="/static/js/extjs/ext-all.js"></script>
  <script type="text/javascript" src="/static/js/extjs/examples/grid/GroupSummary.js"></script>
</%def>

<%def name="menu_js()">
  <script type="text/javascript" src="/static/js/menu/menubar.js"></script>
  <script type="text/javascript" src="/static/js/menu/menu.js"></script>
</%def>

<%def name="onload()">
</%def>

<%def name="js_add()">
</%def>

${self.js()}
${self.menu_js()}

 <script type="text/javascript">
    function getElementsByClass(searchClass,node,tag) {
        var classElements = new Array();
        if (node == null) node = document;
        if (tag == null) tag = '*';
        var els = node.getElementsByTagName(tag);
        var elsLen = els.length;
        var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
        for (i = 0, j = 0; i < elsLen; i++) {
            if (pattern.test(els[i].className) ) {
                classElements[j] = els[i];
                j++;
            }
        }
        return classElements;
    }

    function order_by(condition) {
        document.fast_search.order_by.value = condition;
            document.fast_search.submit();
    }
    function page(n) {
        document.fast_search.page.value = n;
            document.fast_search.submit();
    }
    function toggle(id) {
        var e = document.getElementById(id);
        if (e) {
            e.style.display = e.style.display=='block' ? 'none' : 'block';
        }
        return false;
    }

    function varToggle(link, id) {
        toggle(id);
        var s = link.getElementsByTagName('span')[0];
        var uarr = String.fromCharCode(0x25b6);
        var darr = String.fromCharCode(0x25bc);
        s.innerHTML = s.innerHTML == uarr ? darr : uarr;
        return false;
    }

    function popup(id) {
        var elem = document.getElementById(id);
        elem.style.left='30%';
        elem.style.top ='30%';
        elem.style.marginLeft ='auto';
        elem.style.marginRight='auto';
        elem.style.minWidth='25%';
        elem.style.padding ='15px';
        elem.style.display = "block";
        return false;
    }

    function go_to_url_or_cancel(ask, url) {
        var answer = confirm(ask);
        if (answer){
            window.location = url;
        }
        else {
            return false;
        }
    }

    function setPopUp(node, tag) {
        // setup an onclick listener for all tags 'a' in div 'content' with class 'popup'
        node = document.getElementById(node);
        var popup_list = []
        popup_list = getElementsByClass('popup', node, tag);
        for (i = 0; i < popup_list.length; i++) {
            if (popup_list[i]) {
                popup_list[i].onclick = openPopUp;
                }
            }
        }

    function openPopUp() {
        window.open(this.href, '', 'top=200, left=200, width=480, height=320, status=no, menubar=no, toolbar=no scrollbar=no');
        return false;
    }

    window.onload = function() {
        //enableTooltips('content');
        setPopUp('content', 'a');
        ${self.onload()}
    }

    ${self.js_add()}
</script>

<style type="text/css">
    <%def name="style()">
    </%def> ${self.style()}
</style>



#################################
  </head>

  <body>
    <%def name="container_popup()">
        <div id="content">
            ${self.body()}
        </div>
    </%def>

<%def name="container()">
    <div id="container">
    
        <div id="header">
            ${self.header()}
        </div>
        
        <div id="main_menu">
            <div id="app-menubar"></div>
        </div>
        
        <div id="page">
            <div id="navigation_menu">
                ${self.navigation_menu()}
                
                <div class="extra_menu">                
                     ${self.extra_menu()}
                </div>
            </div>
                
            <div id="content">
                <div id="navigation_filter">
                    ${self.navigation_filter()}
                </div>
            
                <div id="main_content">
                    ${self.content()}
                </div>
            </div>
            
            <div style="clear: both;"></div>
        </div>

        <div id="footer">
            ${self.footer()}
        </div>
    </div>
</%def>

    % if 'popup' in getattr(request, request.method):
        ${self.container_popup()}
    % else:
        ${self.container()}
    % endif

</body>
</html>
## page header, logo % Co.
<%def name="header()">
    <div id="logo">
        <img src="/static/img/logo.gif" alt="Logo Thunder" style="margin:5px;" />
    </div>
    <div id="user-tools">
        % if user.is_authenticated():
            <a href="/accounts/logout/?next=/accounts/login">Logout ${user.username} </a>
            % if user.is_staff:
                | <a href="/admin/"> Admin</a>
            % endif
        % else:
            <a href="/accounts/login/">Login</a>
        % endif
        | <a href="/help${request.path}" >Help</a>
    </div>
</%def>
## mail_menu
    <%def name="main_menu()">
    	<div id="horizontal_menu">
	        ${menu.mako_create_menu(context, father = '1', levels_to_show = 1,
    	      mode = 'horizontal', order_by='name')}
    	</div>
    	<div style="clear:left;"></div>
   </%def>

## navigation menu
    <%def name="navigation_menu()">
      <div class="box-blue">
         <h2 class="section"><b>Menu</b></h2>
            <div class="content">  
                ${menu.mako_create_menu(context, father = jun.menu_path(context),
                levels_to_show = 2, mode = 'vertical', level_to_start = 2)}
            </div>
      </div>
    </%def>

## Extra right menu
    <%def name="extra_menu()">
    </%def>
    
## navigation filter
    <%def name="navigation_filter()">
    </%def>

    <%def name="search_form(model, display='none')">
        <% 
            exp = jun.expander_div('fast_search_div', 'parametri ricerca', display=display)
            f = jun.mako_fast_search(context, model, style='-', render=False) 
            return exp + f.render() + '</div>'
        %>
    </%def>

## content
    <%def name="content()">    
        ${jun.display_messages(messages)}
        ${self.body()}
    </%def>

## footer
    <%def name="footer()">
        <p>Powered By Thunder Systems</p>
    </%def>

### functions
    <%def name="ifdef(arg, default)">
        <%
            val = context.get(arg, default)
            if not val: return ''
            else: return val
        %>
    </%def>
    <%def name="ifdef_in_request(arg, default)">
        <%
            REQUEST = getattr(request, request.method)
            if REQUEST and arg in REQUEST:
                val = REQUEST[arg]
            else:
                val = default
            return val
        %>
    </%def>
    <%def name="ifdef_local_request(arg, default)">
        <%
            val = context.get(arg)
            if not val:
                REQUEST = getattr(request, request.method)
            if REQUEST and arg in REQUEST:
                val = REQUEST[arg]
            else:
                val = default
            return val
        %>
    </%def>
    <%def name="ifdef_request_local(arg, default)">
        <%
            req = context.get('request')
            if req and arg in req:
                val = req[arg]
            else:
                val = context.get(arg, default)
            return val
        %>
    </%def>
    <%def name="fast_search(*args, **kwargs)">
        <% return jun.mako_fast_search(context, *args, **kwargs) %>
    </%def>
