from django.conf.urls.defaults import *

models = 'ambient|category|virtual|device|message|timer|map|position|prog|rule|icon'
default_model = 'virtual'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)',
    }

urlpatterns = patterns('jungle',
  (r'^$',                                           'domotics.views.object_list', {'model':default_model}),
  (r'^%(model)s/del/%(object_id)s/?$' % M,          'views.mgeneric.delete_object', {'template_name' : '/delete_confirmation.mako'}),
  (r'^%(model)s/?$' % M,                            'domotics.views.object_list'),
  (r'^%(model)s/list/$' % M,                        'domotics.views.object_list'),
  (r'^%(model)s/add/?$' % M,                        'apps.domotics.views.add'),
  (r'^%(model)s/edit/%(object_id)s/?$' % M,         'apps.domotics.views.update'),
  (r'^%(model)s/search/?$' % M,                     'views.fast_search.search'),
  (r'^%(model)s/file/add/%(object_id)s/?$' % M,     'domotics.views.file_add'),
  (r'^%(model)s/%(object_id)s/$'  % M,              'views.mgeneric.object_detail'),
)


urlpatterns += patterns('',
#  (r'^%(model)s/add/?$'  % M,      'jungle.views.generic.create_object'),
#  (r'^%(model)s/add/?$'  % M,      'jungle.views.generic.create_object'),
   (r'^surface/' % M,               'jungle.domotics.views.object_list', {'model':'map', 'template_name':'domotics/surface.mako'}),
)
