from django import newforms as forms
from jungle.fax.models import Fax
from django.newforms.models import form_for_model

class ForwardForm(form_for_model(Fax)):
    def __init__(self, *args, **kwargs):
        from django.newforms.fields import CharField

        super(ForwardForm, self).__init__(*args, **kwargs)
        self.fields['file'] = CharField()        

    def save(self):
        from django.contrib.auth.models import User
        from jungle.organization.models import OrganizationGroup
        
        cleaned_data = self.cleaned_data
        if cleaned_data['recipient_list']:
            f = Fax(
                subject = cleaned_data['subject'],
                submitter = User.objects.get(id=cleaned_data['submitter']),
                keywords = cleaned_data['keywords'],
                recipient_list = OrganizationGroup.objects.get(id=cleaned_data['recipient_list']),
                file = cleaned_data['file'],
                status = 6,
            )
        else:    
            f = Fax(
                subject = cleaned_data['subject'],
                submitter = User.objects.get(id=cleaned_data['submitter']),
                keywords = cleaned_data['keywords'],
                recipient = cleaned_data['recipient'],
                recipient_number = cleaned_data['recipient_number'],
                file = cleaned_data['file'],
                status = 6,
            )
        f.save()
        return f
