from django.conf.urls.defaults import *

models = 'fax|sendfax'
default_model = 'fax'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)',
#    'mode'      : '(?P<mode>all|closed|open)?',
    }

default_filter = { 'status__exact' : 2, 'read__exact' : 0 }

urlpatterns = patterns('jungle',
  (r'^$',                                           'fax.views.object_list', {'model' : default_model, 'filter_cnd' : default_filter }),
  (r'^%(model)s/get/%(object_id)s/?$' % M,          'apps.fax.views.get'),
  (r'^%(model)s/edit/%(object_id)s/?$' % M,         'apps.fax.views.update'),
#  (r'^%(model)s/del/%(object_id)s/?$' % M,          'views.mgeneric.delete_object'),
  (r'^%(model)s/show/%(object_id)s/$'  % M,         'views.mgeneric.object_detail'),
  (r'^%(model)s/report/%(object_id)s/$'  % M,       'fax.views.report_pdf'),  
  (r'^%(model)s/?$' % M,                            'fax.views.object_list', { 'filter_cnd' : default_filter }),
  (r'^%(model)s/list/$' % M,                        'fax.views.object_list'),
  #(r'^%(model)s/search/?$' % M,                     'views.fast_search.search'),
  (r'^%(model)s/file/add/%(object_id)s/?$' % M,     'fax.views.file_add'),
)


urlpatterns += patterns('jungle',
  (r'^fax/send/?$' % M,                             'apps.fax.views.send', {'template_name' : 'fax/sendfax_form.mako'}),
  (r'^fax/forward/%(object_id)s/?$' % M,            'fax.views.forward'),
  (r'^fax/del/%(object_id)s/?$' % M,            'fax.views.del_from_queue'),
)
