from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.organization.models import Organization, OrganizationGroup
from jungle.fax.models import Fax
from django.conf import settings
from sendfax import SendFaxForm

@login_required
def object_list(request, model, filter_cnd={}, order_by='-date_create',
                search_params={}, form=None, **kw):

    if model == 'fax':
        queryset = Fax.objects.all()

    return generic.jobject_list(request, queryset, model, form,
                                filter_cnd, order_by, **kw)

@login_required
def add(request, model='sendfax', **kw):
    kw.update({'post_save_redirect' : settings.LOCATION + 'fax/fax/list/'})

    return generic.create_object(request, model, **kw)

@login_required
def update(request, model=None, object_id=None, **kw):
    kw.update({'post_save_redirect' : settings.LOCATION + 'fax/fax/show/%s/' % object_id})
    
    kw['extra_context'] = {'mode' : 'update'}

    return generic.update_object(request, model, object_id, ext="_update", **kw)

@login_required
def file_add(request, model, id):
    from file_form import FileForm

@login_required
def get(request, model, object_id):
    from django.views.static import serve

    f = Fax.objects.get(pk=object_id)
    f.read = 1
    f.hsave()

    name = f.get_file_url().lstrip('/')
    return serve(request, name, settings.CWD)
    
@login_required
def forward(request, object_id, model='sendfax', **kw):
    from forms_forward import ForwardForm as form

    kw.update({
        'form' : SendFaxForm,
        'template_name'      : 'fax/sendfax_form.mako',
        'post_save_redirect' : settings.LOCATION + 'fax/fax/list/',
        'extra_context'      : {
              'clone' : Fax.objects.get(id=object_id)},
    })

    return generic.create_object(request, model, **kw)

@login_required
def report_pdf(request, model, object_id):
    from reportlab.pdfgen import canvas
    from django.http import HttpResponse
    
    f = Fax.objects.get(pk=object_id)
    
    response = HttpResponse(mimetype='application/pdf')
    response['Content-Disposition'] = 'attachment; filename=report_%s.pdf' % f.id

    p = canvas.Canvas(response)

    if f.status == 2:
        p.drawString(30, 800, 'Mittente: %s' % f.sender)
        p.drawString(30, 780, 'ID Lavoro: %s' % f.job)
        p.drawString(30, 760, 'Data e ora ricezione: %s' % f.date_last_modify)
        p.drawString(30, 740, 'Tempo di ricezione: %s' % f.duration)
        p.drawString(30, 720, 'Pagine ricevute: %s' % f.pages)        

    elif f.status in (4, 5): #sent or failed
        if f.status == 4:
            confirm = 'OK'
        else:
            confirm = f.error

        p.drawString(30, 800, 'Destinatario: %s' % f.recipient)
        p.drawString(30, 780, 'Oggetto del Fax: %s' % f.subject)
        p.drawString(30, 760, 'ID Lavoro: %s' % f.job)
        p.drawString(30, 740, 'Data e ora spedizione: %s' % f.date_last_modify)
        p.drawString(30, 720, 'Conferma Invio: %s' % confirm)
        p.drawString(30, 700, 'Tempo di spedizione: %s' % f.duration)
        p.drawString(30, 680, 'Pagine inviate: %s' % f.pages)

    p.showPage()
    p.save()
    
    return response

@login_required
def send(request, model='sendfax', **kw):

    kw.update({        'form' : SendFaxForm,
                'post_save_redirect' : settings.LOCATION + 'fax/fax/list/',
    })

    return generic.create_object(request, model, **kw)

@login_required
def del_from_queue(request, object_id, **kw):
    import subprocess as sub
    import time

    f = Fax.objects.get(pk=object_id)    

    if f.job and f.status in (3, 6):
        cmd = "faxrm %s" % f.job

        p = sub.Popen(cmd.split(), stdout=sub.PIPE)

        output = p.communicate()[0]
        time.sleep(5)

    from django.views.generic.simple import redirect_to

    return redirect_to(request, '%sfax/fax/list/?status=3' % settings.LOCATION, **kw)
