from django.db import models
from django.contrib.contenttypes.models import ContentType
from jungle.templatetags.jungle_tags import ugettext as _

# Create your models here.

STATUS_CODES = (
    ( 0, 'Active'),
    ( 1, 'Inactive')
)

class File(models.Model):
    ## Campi generici
    date_create = models.DateTimeField (
        auto_now_add=True,
        verbose_name="Data Creazione",
        null=True,
    )
    date_last_modify = models.DateTimeField (
        auto_now=True,
        verbose_name="Data Ultima Modifica",
        null=True,
    )
    status = models.IntegerField (
        blank=True,
        max_length=3,
        default='0',
        choices=STATUS_CODES,
        verbose_name="Stato",
    )
    ## Campi
    title = models.CharField (
        blank=True,
        null=True,
        max_length=100,
    )
    type = models.IntegerField(
        'FileType',
        blank=True,
        null=True,
        )
    file_obj = models.FileField(upload_to='files')
    notes = models.CharField(max_length=255, blank=True, null=True)
    content_type = models.ForeignKey(ContentType)
    object_id = models.IntegerField(_('object ID'))
    perm = models.CharField(max_length=10, blank=True, null=True)

    def __unicode__(self):
        return unicode(self.title) or unicode(self.file_obj)
    
    def save(self):
        import os
        if not self.title:
            self.title = self.file_obj.replace('files/','').replace(' ','_')
        name, ext = os.path.splitext(self.file_obj)
        #self.file_obj = "%s-%s" % (self.content
        super(File, self).save()

    class Admin:
        pass
