var myForm; // Form di appoggio per la stampa degli appuntamenti
var NUM_PER_PAGE = 200; // Numero di righe visualizzate in ogni pagina della griglia
var grid;

Ext.onReady(function(){      
    Ext.get('reload_firewall').on('click', confirm_reload);
    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/firewall/dnatrule/edit/"+record.id+"/"+record.data.type_rule+"'><img src='/static/img/edit.gif' title=\"Modifica Regola\" /></a>");
    }

    function renderDelete(value, p, record){
       return String.format(popup_delete("/firewall/dnatrule/del/"+record.id+"/?popup", "Elimina Regola"));
    }

    function renderStatus(value, p, record){
        color = 'black';
        if (value == 'Attivo')
            color = "green";
        if (value == 'Inattivo')
            color = "red";        
        return String.format("<font color='"+ color + "'>" + value + "</font>");
    }
    
    function renderRegola(value, p, record){
        return String.format("<font color='red'>Accesso consentito da: </font>" + record.data.ip_src + "&nbsp;&nbsp;&nbsp;&nbsp;(" + record.data.note + ")");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/firewall/dnatrule/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'status'},
            {name: 'proto'},
            {name: 'ip_src'},
            {name: 'dst_pre'},
            {name: 'dst_nat'},
            {name: 'status'},
            {name: 'dst_pre_port'},
            {name: 'dst_nat_port'},
            {name: 'snat'},
            {name: 'note'},
            {name: 'grouping_field'},
            {name: 'type_rule'},
            {name: 'edit'},
            {name: 'delete'}
        ]
    });
        
    var cm = new Ext.grid.ColumnModel([
        {header: "Stato", width:10, align:"center", dataIndex: 'status',
            editor: new Ext.form.ComboBox({
                typeAhead: true,
                triggerAction: 'all',
                transform:'status',
                lazyRender:true,
                listClass: 'x-combo-list-small'
            }),
         renderer: renderStatus},

        {header: "Prot.", width:10, align:"center", dataIndex: 'proto', summaryType: 'max',
            summaryRenderer: function(v, params, data){return 'Totale : ';}},
                     
        {header: "", width:80, dataIndex: 'dst_pre', renderer: renderRegola, summaryType: 'count', 
            summaryRenderer: function(v, params, data){
                                return ((v === 0 || v > 1) ? v +' Regole' : '1 Regola');
                             }},

        //{header: "", width:1, dataIndex: 'ip_src', hidden: true},                                                      
        {header: "Sorgente", width:1, dataIndex: 'grouping_field', hidden: true},
        
        {header: "", width: 8, align:"center", renderer: renderEdit, 
            dataIndex: 'view_icon'},
        {header: "", width: 8, align:"center", renderer: renderDelete, 
            dataIndex: 'view_icon'}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: false,
        groupField: 'grouping_field',
        remoteGroup: true,
        baseParams : {t: get_querystring_parameter('t')}
    });
    
    grid = new Ext.grid.EditorGridPanel({
        el:'grid_dnatrule',
        title:'Lista Regole Port Forwarding',
        width:'100%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
                
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),

        // bottom toolbars
        bbar: new Ext.PagingToolbar({
            pageSize: NUM_PER_PAGE,
            store: ds,
            displayInfo: true,
            displayMsg: 'Visualizzo regole {0} - {1} di {2}',
            emptyMsg: "Nessuna regola da visualizzare"
        }),
                
        plugins: new Ext.grid.GroupSummary(),
        clicksToEdit:1
    });
    
    grid.render();
    
    grid.on('afteredit', updateDB);

    function updateDB(oGrid_Event){
        //update the database
        Ext.Ajax.request(
            { //ajax request configuration  
                waitMsg: 'Saving changes...',
                url: '/firewall/dnatrule/ajax/change_status/', //url to server side script

                params: { //these will be available via $_POST or $_REQUEST:
                    task: "update", //pass task to do to the server script
                    key: 'id',//pass to server same 'id' that the reader used
                    keyID: oGrid_Event.record.id,//for existing records this is the unique id (we need this one to relate to the db)
                    //newRecord: isNewRecord,//pass the new Record status indicator to server for special handling
                    field: oGrid_Event.field,//the column name
                    value: oGrid_Event.value,//the updated value
                    originalValue: !oGrid_Event.record.modified
                },//end params

                failure:function(response,options){
                    Ext.MessageBox.alert('Warning','Oops...');
                },//end failure block

                success:function(response,options){
                    //Ext.MessageBox.alert('Success','Yeah...');
                     ds.commitChanges();//commit changes (removes the red triangle which indicates a 'dirty' field)
                     grid.getStore().reload();
                     document.getElementById("message_status").innerHTML = "ATTENZIONE!! RIAVVIARE IL FIREWALL PER RENDERE EFFETTIVE LE MODIFICHE";
                }//end success block
             }//end ajax request config
        ); //end ajax request  
    }
    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
});


function confirm_reload() {
    // Show a dialog using config options:
    Ext.Msg.show({
       title:'Attenzione?',
       msg: 'Sei sicuro di voler riavviare il firewall?',
       buttons: Ext.Msg.YESNOCANCEL,
       fn: processResult,
       icon: Ext.MessageBox.QUESTION
    }); 
}

function processResult(answer){
    if (answer=='yes') {
        Ext.MessageBox.show({
            msg: 'Attendere prego...',
            progressText: 'Il firewall si sta riavviando...',
            width: 300,
            wait: true,
            waitConfig: {
                interval: 200
            },
            animEl: 'reload_firewall'
        });
        
        Ext.Ajax.timeout = '200000';
        // Call to reload firewall
        Ext.Ajax.request({
            url: '/firewall/reload_firewall',
            success: f_success,
            failure: f_failure
        });     
    }   
}

function f_success(result){
    if (result.responseText == 'OK') {
        var title = 'FIREWALL RIAVVIATO!';
        var msg = "Il firewall e' stato riavviato correttamente.";
        var icon = Ext.MessageBox.INFO;
        document.getElementById("message_status").innerHTML = "";
    }
    else {
        var title = 'ERRORE!';
        var msg = result.responseText;
        var icon = Ext.MessageBox.ERROR;    
    }

    Ext.Msg.show({
        title: title,
        width: 400,
        msg: msg,
        buttons: Ext.Msg.OK,
        icon: icon
    });
}

function f_failure(result){
    Ext.Msg.show({
       title:'ERRORE!',
       width: 400,
       msg: "C'e' stato un errore mentre il firewall si riavviava. Contattare l'amministratore.",
       buttons: Ext.Msg.OK,
       icon: Ext.MessageBox.ERROR
    });
}