from django.conf.urls.defaults import *

models = 'dnatrule'
default_model = 'dnatrule'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)',
    }

urlpatterns = patterns('jungle',
    (r'^$',                                 'firewall.views.object_list', {'model':default_model}),
    (r'^%(model)s/?$'                       % M, 'firewall.views.object_list'),
    (r'^%(model)s/list/$'                   % M, 'firewall.views.object_list'),
    (r'^%(model)s/add/?$'                   % M, 'firewall.views.add'),    
    (r'^%(model)s/%(object_id)s/?$'         % M, 'firewall.views.object_detail'),
    (r'^%(model)s/edit/%(object_id)s/?$'    % M, 'firewall.views.update'),

    (r'^%(model)s/del/%(object_id)s/?$'     % M, 'views.mgeneric.delete_object',
                 {'post_delete_redirect' :'/views/close_popup/'}),
    
    (r'^%(model)s/ajax/list/?$'             % M, 'firewall.views.get_search_data'),
    (r'^%(model)s/ajax/change_status/?$'    % M, 'firewall.views.change_status'),
    (r'^reload_firewall/?$'                  , 'firewall.views.reload_firewall'),
)