from jungle.template import mako_loader 
#from django.conf import settings
from jungle.templatetags.jungle_tags import ReST
from django.template import RequestContext
import os, re

def help(request, app, url):
    """
    this function will try to return help-app.(html/rst), help.html or help.rst 
    file found (if any) in the template dir of the module

    If no specific module is found (ie: application/help.txt) a file
    /help.txt will be searched with the same rules as template lookup

    A way of browsing other pages is granted through 'page' arg::

      localhost/help/ticket/?page=index

    """
#    import ipdb; ipdb.set_trace()    
    page = request.GET.get('page', 'help')
    #print "app: %s, url: %s, page=%s" % (app, url, page)
    path = app + url

    t = None
    for dirname in (app, ''):
        t, ext = get_help_file(dirname, page, url)
        if t:
            break
        
    ## fallback to normal help page
    if not t:
        t, ext = get_help_file(dirname, 'help', url)

    if t:
        txt = t.render_unicode()
        if ext == 'rst':
            txt = ReST(txt)
        
    return mako_loader.render_to_response('help/help_detail.mako',
                              {'txt' : txt, 'path':path},
                              context_instance=RequestContext(request),)     

def get_help_file(name, page, url):
    t = None
    try:
        model = url.split('/')[1]
    except:
        model = ''
    ## first more specific one
    for ext in ('html', 'rst'):
        try:
            t = mako_loader.get_template('%s/%s-%s.%s' % (name, page, model, ext))
            return (t, ext)
        except (mako_loader.TemplateDoesNotExist), e:
            #import ipdb; ipdb.set_trace()
            pass
        
    for ext in ('html', 'rst'):
        try:
            t = mako_loader.get_template('%s/%s.%s' % (name, page, ext))
            return (t, ext)
        except mako_loader.TemplateDoesNotExist:
            pass


