from django.dispatch import dispatcher
from django.db.models import signals
from jungle.mailserver import models 
import django.db

create_views = """
CREATE VIEW mailserver_alias_view AS
    SELECT (((a.alias)::text || '@'::text) || (d.name)::text) AS alias, a.address, a.status
    FROM (mailserver_alias a LEFT JOIN mailserver_domain d ON (((a.domain_id = d.id) AND (d.status <> 0))))
    UNION (SELECT (a.account::text || '@'::text || d.name) as alias, CASE WHEN v.status = 1 THEN 'autoresponder@vacation.local, '
    ELSE ''::text END || CASE WHEN a.backup = True THEN (a.account || '@' || d.name || '@backup.local, ')
    ELSE ''::text END || CASE WHEN v.status = 1 OR a.backup = True THEN (a.account || '@' || d.name)
    ELSE ''::text END as account, a.status FROM mailserver_account a LEFT JOIN mailserver_vacation v ON (v.account_id = a.id)
    JOIN mailserver_domain d ON (a.domain_id = d.id) where a.status = 1 AND d.status = 1 AND (v.status = 1 OR a.backup = True));

CREATE VIEW mailserver_account_view AS
    SELECT (((a.account)::text || '@'::text) || (d.name)::text) AS account,
    a.home_dir, (a.quota*1048576)::bigint as quota, a.status, a.pwd, a.disable_imap_login::int,
    a.disable_pop_login::int FROM (mailserver_account a LEFT JOIN mailserver_domain d ON
    (((a.domain_id = d.id) AND (d.status <> 0))));
"""

def init_data():
    cursor = db.cursor()
try:
    cursor.execute(create_views)
    db.commit()
except:
    pass

dispatcher.connect(init_data, sender=models, signal=signals.post_syncdb)
