from django.test.client import Client
from jungle.tests import NoFixtures

POST_ADD = (
    ('/mailserver/domain/add/', dict(postmaster=1, name='tksql.org', users=1, aliases=2,
                                     transport='virtual', status=1, creator=1, quota=0)),

    ('/mailserver/account/add/', dict(account='info', domain=1, pwd='secret',
                                      status=1, quota=0, postmaster=1)),

#    ('/mailserver/account/edit/pwd/1/', dict(pwd='changed', pwd_2='changed')),

    ('/mailserver/alias/add/', dict(alias='support', domain=1, status=1,
                                    addresses='first@email.com;second@email.com')), 
    )
GET = (
    '/mailserver/domain/1/',
    '/mailserver/account/1/',
    '/mailserver/alias/show/support/1/',
    )

LOGIN_REQUIRED = (
    ('/mailserver/domain/', {}),
    ('/mailserver/domain/add/', {}),
    ('/mailserver/domain/list/', {}),
    ('/mailserver/account/', {}),
    ('/mailserver/account/add/', {}),
    ('/mailserver/account/list/', {}),
    ('/mailserver/alias/', {}),
    ('/mailserver/alias/add/', {}),
    ('/mailserver/alias/list/', {}),
    )


class Menu(NoFixtures):
    app_label = 'mailserver'
    post_get = POST_ADD
    get = GET
    login_required = LOGIN_REQUIRED

    def setUp(self):
        USERNAME = 'tester'
        PASSWORD = 'passwd'

        from django.contrib.auth.models import User, Group
        supermaster = Group.objects.get(name = 'Supermaster')
        u, existent = User.objects.get_or_create(username=USERNAME,  )
        u.set_password(PASSWORD)
        u.is_staff = True
        u.groups.add(supermaster)
        u.save()

        #import pdb; pdb.set_trace()
        self.client = Client()
        ## attenzione: questa pagine deve esistere e non deve dare errori!
        ret = self.client.login(username=USERNAME, password=PASSWORD)
