from django.conf.urls.defaults import *
from jungle.views.decorators import login_required

models = 'domain|account|alias|vacation'
default_model = 'domain'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)',
    }

urlpatterns = patterns('jungle',
  (r'^$',                                        'mailserver.views.object_list', {'model': default_model}),
  (r'^%(model)s/edit/%(object_id)s/?$' % M,      'mailserver.views.update'),
# edit PWD
  (r'^%(model)s/edit/pwd/%(object_id)s/?$' % M, 'mailserver.views.update', {'template_name' : 'mailserver/account_form_pwd_update.mako'}),
  (r'^reload/$' %M,    'views.mgeneric.close_popup'),
###
### DELETE for mailserver accounts and domains has a
### specific view at mailserver.views.delete_account_or_domain
  (r'^%(model)s/del/%(object_id)s/$' % M,       'views.mgeneric.delete_object', {'login_required' : True}),
  #(r'^%s/del/(?P<object_id>\d+)/$' % '(?P<model>alias)',       'views.mgeneric.delete_object', {'login_required' : True}),
  (r'^%(model)s/?$' % M,                         'mailserver.views.object_list'),
  (r'^%(model)s/list/$' % M,                     'mailserver.views.object_list'),
  (r'^%(model)s/add/?$' % M,                     'apps.mailserver.views.add'),
#  (r'^%(model)s/file/add/%(object_id)s/?$' % M,  'mailserver.views.file_add'),
#  (r'^%(model)s/(?P<object_id>domain)/$'  % M,           'mailserver.views.object_detail'),
  (r'^(?P<model>domain)/%(object_id)s/$'  % M,           'mailserver.views.object_detail'),
#  (r'^%(model)s/%(object_id)s/$'  % M,           'mailserver.views.object_detail'),
  (r'^%(model)s/%(object_id)s/$'  % M,           'views.mgeneric.object_detail'),

  (r'^alias/show/(?P<alias_name>.+)/(?P<domain_id>\d+)/?$', 'apps.mailserver.views.alias_detail'),
  (r'^alias/add/(?P<alias_name>.+)/(?P<domain_id>\d+)/?$' % M, 'apps.mailserver.views.add', {'model': 'alias'}),
  (r'postmaster/add/?$', 'mailserver.views.add_postmaster'),
# url for ACCOUNT and DOMAIN complete deletion
  (r'^(?P<model>account|domain)/remove/%(object_id)s/$' % M, 'mailserver.views.delete_account_or_domain'),
)
