from django.views.generic.list_detail import object_list
from django.views.generic.create_update import create_object, update_object
from django.views.generic.date_based import archive_year, archive_month, archive_day
from django.shortcuts import render_to_response, get_object_or_404
from django import forms as forms_django
from models import News, NewsType, Postit, PostitType

# Create your views here.

def news(request, type, page=None, object_id=None, year=None, month=None, day=None):
    if type == 'list':
        queryset = News.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if type == 'add':
        model = News
        return create_object (request, model)
    if type == 'edit':
        model = News
        return update_object (request, model, object_id)
    if type == 'date':
        queryset = News.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list)

def news_type(request, type, page=None, object_id=None, year=None, month=None, day=None):
    if type == 'list':
        queryset = NewsType.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if type == 'add':
        model = NewsType
        return create_object (request, model)
    if type == 'edit':
        model = NewsType
        return update_object (request, model, object_id)
    if type == 'date':
        queryset = NewsType.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list)

def postit(request, type, page=None, object_id=None, year=None, month=None, day=None):
    if type == 'list':
        queryset = Postit.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if type == 'add':
        model = Postit
        return create_object (request, model)
    if type == 'edit':
        model = Postit
        return update_object (request, model, object_id)
    if type == 'date':
        queryset = Postit.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list)

def postit_type(request, type, page=None, object_id=None, year=None, month=None, day=None):
    if type == 'list':
        queryset = PostitType.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if type == 'add':
        model = PostitType
        return create_object (request, model)
    if type == 'edit':
        model = PostitType
        return update_object (request, model, object_id)
    if type == 'date':
        queryset = PostitType.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list)
