from django.db import models

# Create your models here.

STATUS_CODES = (
    ( 1, 'Active'),
    ( 0, 'Inactive')
)

class NewsLetter (models.Model):
    ## Campi generici
    date_create = models.DateTimeField (
        auto_now_add=True,
        verbose_name="Data Creazione",
    )
    date_last_modify = models.DateTimeField (
        auto_now=True,
        verbose_name="Data Modifica",
    )
    status = models.IntegerField (
        max_length=3,
        default='1',
        choices=STATUS_CODES,
        verbose_name="Stato",
    )
    ## ForeignKey
    ## Campi
    email = models.EmailField (
        unique=True,
        max_length=100,
        verbose_name="Email",
    )

    class Admin:
        search_fields = ("status", "email",)
        date_hierarchy = "date_create"
        list_display = ("status", "email",)
        list_display_links = ("email",)
        list_per_page = 30
        fields = (
            (None, {"fields":(
                ("status", "email",),
            ),}),
        )
        ordering = ("email",)

    class Meta:
        verbose_name = "Newsletter"
        verbose_name_plural = "Newsletter"

    def __unicode__(self):
        return unicode(self.email)    