from django.views.generic.list_detail import object_list
from django.views.generic.create_update import create_object, update_object
from django.views.generic.date_based import archive_year, archive_month, archive_day
from django.shortcuts import render_to_response, get_object_or_404
from django import forms as forms_django
from models import NewsLetter

# Create your views here.

def newsletter(request, type, page=None, object_id=None, year=None, month=None, day=None):
    if type == 'list':
        queryset = NewsLetter.objects.all()
        paginate_by = 2
        return object_list(request, queryset, paginate_by, page)
    if type == 'add':
        model = NewsLetter
        return create_object (request, model)
    if type == 'edit':
        model = NewsLetter
        return update_object (request, model, object_id)
    if type == 'date':
        queryset = NewsLetter.objects.all()
        date_field = 'date_create'
        make_object_list = True
        return archive_year (request, queryset, year, date_field, make_object_list)
