# -*- coding: utf-8 -*-

from jungle.openvpn.models import FwGroupRules
from django.newforms import ModelForm
from django.db import transaction
from django.conf import settings
from jungle.functions.conf import *
import os, os.path
from jungle.template import mako_loader as mloader

class FwGroupForm(ModelForm):       
    GROUP_RULES_PATH = settings.GROUP_RULES_PATH
    
    class Meta:
        model = FwGroupRules
        fields = ('name',)

#    @transaction.commit_manually
    def save(self):
        try:
            group = super(FwGroupForm, self).save(commit=False)
                    
            file_name = self.cleaned_data['name'].replace(' ', '').lower()
            group.file = file_name
            group.save()
            
            fw_file = os.path.join(self.GROUP_RULES_PATH, "%s.fw" % file_name)        
            conf_file = mloader.render_to_response("openvpn/default_group_fw.mako", {'group':file_name})
    
            f = open(fw_file, 'w')    
            f.write(conf_file.content)    
            f.close()
        except Exception, e:
            transaction.rollback()
            raise Exception(e)
        else:
            transaction.commit()
            return group