# -*- coding: utf-8 -*-

from jungle.openvpn.models import FwGroup, FwRule, Certificate
from django.newforms import ModelForm
from django.db import transaction
from jungle.functions.conf import *
import os, os.path
from jungle.template import mako_loader as mloader
from django.newforms.util import ValidationError

       
class FwRuleForm(ModelForm):       
    class Meta:
        model = FwRule

    def save(self):
        rule = super(FwRuleForm, self).save()

        # Cerco tt i certificati che hanno come gruppo uno di quelli
        # associati alla regola che si sta salvando, e ne chiamo il metodo
        # refresh_rules che crea/modifica le relative regole.
        #
        for group in rule.group.all():
            l_cert = Certificate.objects.filter(group__exact=group.id)
            for c in l_cert:
                c.refresh_rules()
                    
        return rule


class FwRuleFormUpdate(FwRuleForm):           
    def __init__(self, *args, **kwargs):
        self.rule = FwRule.objects.get(id=args[0]['id'])
        kwargs['instance'] = self.rule
        super(FwRuleFormUpdate, self).__init__(*args, **kwargs)
