var NUM_PER_PAGE = 25; // Numero di righe visualizzate in ogni pagina della griglia
var grid_rules;

Ext.onReady(function(){    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/openvpn/fwrule/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Modifica Regola\" /></a>");
    }

    function renderDelete(value, p, record){
       return String.format(popup_delete("/openvpn/fwrule/del/"+record.id+"/?popup=true", "Elimina Regola"));
    }
        
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
        
    var myProxy = new Ext.data.HttpProxy({
        url: '/openvpn/fwrule/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'group'},
            {name: 'table'},
            {name: 'chain'},
            {name: 'd_ip'},
            {name: 'proto'},
            {name: 'd_port'},
            {name: 'action'},
            {name: 'order'},
            {name: 'edit'},
            {name: 'delete'}            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Group", width:25, dataIndex: 'group'},
        
        {header: "Table", width:20, dataIndex: 'table', summaryType: 'count',
            summaryRenderer: function(v, params, data){return 'Totale';}},
            
        {header: "Chain", width:20, dataIndex: 'chain', summaryType: 'count',
            summaryRenderer: function(v, params, data){
                                return ((v === 0 || v > 1) ? v +' Regole' : '1 Regola');
                             }},
            
        {header: "Destination IP", width:30, dataIndex: 'd_ip'},
        {header: "Protocol", width:15, dataIndex: 'proto'},
        {header: "Dest. Port", width:15, dataIndex: 'd_port'},
        {header: "Action", width:25, dataIndex: 'action'},
        {header: "Order", width:10, dataIndex: 'order'},
        
        {header: "", width: 8, align:"center", renderer: renderEdit, 
            dataIndex: 'edit'},
        {header: "", width: 8, align:"center", renderer: renderDelete, 
            dataIndex: 'delete'}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'group',
        remoteGroup: true
    });
    
    //ds.setDefaultSort('data_appuntamento', 'DESC');
    
    grid_rules = new Ext.grid.GridPanel({
        el:'grid_rules',
        title:'Lista Regole',        
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
                
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),

        // bottom toolbars
        bbar: new Ext.PagingToolbar({
            pageSize: NUM_PER_PAGE,
            store: ds,
            displayInfo: true,
            displayMsg: 'Visualizzo regole {0} - {1} di {2}',
            emptyMsg: "Nessuna regola da visualizzare"
        }),
                
        plugins: new Ext.grid.GroupSummary()        
    });
    
    grid_rules.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/openvpn/fwrule/ajax/list/',
    //                            'grid':grid_rules,
    //                            'button_id':'cerca'});      
});