var NUM_PER_PAGE = 25; // Numero di righe visualizzate in ogni pagina della griglia
var grid;

Ext.onReady(function(){    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/openvpn/fwgroup/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Modifica Gruppo\" /></a>");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
        
    var myProxy = new Ext.data.HttpProxy({
        url: '/openvpn/fwgroup/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'name'},
            {name: 'edit'}            
        ]
    });

    
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader
    });
        
    var cm = new Ext.grid.ColumnModel([
        {header: "Nome", width:90, dataIndex: 'name'},
        {header: "", width:10, align:"center", renderer: renderEdit, 
            dataIndex: 'edit', resizable : false}        
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    grid = new Ext.grid.GridPanel({
        el:'grid_group',
        title:'Lista Gruppi',        
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
                
        // bottom toolbars
        bbar: new Ext.PagingToolbar({
            pageSize: NUM_PER_PAGE,
            store: ds,
            displayInfo: true,
            displayMsg: 'Visualizzo gruppi {0} - {1} di {2}',
            emptyMsg: "Nessun gruppo da visualizzare"
        })     
    });
    
    grid.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});

    // Aggiungo la ricerca via Ext
    ext_search = new ExtSearch({'url':'/openvpn/fwgroup/ajax/list/',
                                'grid':grid,
                                'button_id':'cerca'});        
});