var NUM_PER_PAGE = 25; // Numero di righe visualizzate in ogni pagina della griglia
var grid_utenti;

Ext.onReady(function(){                                        
    /***********************
     * RENDER FUNCTIONS
     ***********************/
  
    function renderEdit(value, p, record){
        return String.format("<a href='/openvpn/utenti/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Modifica Utente\" /></a>");
    }

    function renderDelete(value, p, record){
        return String.format("<a href='#' onclick='confirm_delete(\""+record.id+"\", \""+record.data.username+"\");return false'><img src='/static/img/delete.gif' title=\"Cancella Utente\" /></a>");
    }
        
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/openvpn/utenti/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},        
            {name: 'username'},
            {name: 'nome'},            
            {name: 'cognome'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Username", width:30, dataIndex: 'username'},
        {header: "Nome", width:30, dataIndex: 'nome'},
        {header: "Cognome", width:30, dataIndex: 'cognome'},
        {header: "", width:10, align:"center", renderer: renderEdit, 
            dataIndex: 'edit', resizable : false},
        {header: "", width:10, align:"center", renderer: renderDelete, 
            dataIndex: 'delete', resizable : false}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });
    ds.setDefaultSort('username', 'ASC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Utenti {0} - {1} di {2}',
        emptyMsg: "Nessun Utente da visualizzare"
    });
    
    grid_utenti = new Ext.grid.GridPanel({
        el:'grid_utenti',
        title:'Lista Utenti Openvpn',        
        width:'80%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar        
    });
    
    grid_utenti.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext   
    ext_search = new ExtSearch({'url':'/openvpn/utenti/ajax/list/',
                                'grid':grid_utenti,
                                'button_id':'cerca'});     
});

function confirm_delete(id, username) {
    ext_confirm = new ExtConfirm({
                        'url': '/openvpn/utenti/ajax/del/'+id+'/',
                        'msgConfirm': "Sei sicuro di voler cacnellare l'utente '<b>" + username + "</b>'?",
                        'progressText': "Cancellazione in corso. Attendere..",
                        'success_msg' : "L'utente e' stato cancellato con successo",
                        'post_confirm' : reload_grid
                 });
    ext_confirm.show();    
}

function reload_grid() {
    grid_utenti.getStore().reload();
}