# configurazione: client
# Sample OpenVPN configuration file for
# office using SSL/TLS mode and RSA certificates/keys.
#
# '#' or ';' may be used to delimit comments.

# Use a dynamic tun device.
# For Linux 2.2 or non-Linux OSes,
# you may want to use an explicit
# unit number such as "tun1".
# OpenVPN also supports virtual
# ethernet "tap" devices.
dev tun
proto tcp-client
tun-mtu 1500
mssfix 1500
# fragment 1300

# 10.1.0.1 is our local VPN endpoint (office).
# 10.1.0.2 is our remote VPN endpoint (home).

remote ${remote}
pull
# Our up script will establish routes
# once the VPN is alive.
#up ./office.up
#up "./scripts/new_key81-brid.sh start"
#down "./scripts/new_key81-brid.sh stop"

route-method exe
route-delay 2

# In SSL/TLS key exchange, Office will
# assume server role and Home
# will assume client role.
tls-client

# Diffie-Hellman Parameters (tls-server only)
#dh keys/dh1024.pem

# Certificate Authority file
ca ca.crt

# Our certificate/public key
cert ${cert}

# Our private key
key ${key}

% if use_password:
auth-user-pass
% endif

# OpenVPN uses UDP port 5000 by default.
# Each OpenVPN tunnel must use
# a different port number.
# lport or rport can be used
# to denote different ports
# for local and remote.
port 1194

# Downgrade UID and GID to
# "nobody" after initialization
# for extra security.
; user nobody
; group nobody

# If you built OpenVPN with
# LZO compression, uncomment
# out the following line.
; comp-lzo

# Send a UDP ping to remote once
# every 15 seconds to keep
# stateful firewall connection
# alive.  Uncomment this
# out if you are using a stateful
# firewall.
; ping 15

# Uncomment this section for a more reliable detection when a system
# loses its connection.  For example, dial-ups or laptops that
# travel to other locations.
ping 15
ping-restart 45
ping-timer-rem
persist-tun
persist-key

# Verbosity level.
# 0 -- quiet except for fatal errors.
# 1 -- mostly quiet, but display non-fatal network errors.
# 3 -- medium output, good for normal operation.
# 9 -- verbose, good for troubleshooting
verb 3
