from django.conf.urls.defaults import *

models = 'key|certificate|connection|fwrule|fwgroup|utenti'
default_model = 'certificate'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)',
    }

urlpatterns = patterns('jungle',
    (r'^$',                                 'openvpn.views.object_list', {'model':default_model}),
    (r'^%(model)s/?$'                       % M, 'openvpn.views.object_list'),
    (r'^%(model)s/list/$'                   % M, 'openvpn.views.object_list'),
    (r'^%(model)s/add/?$'                   % M, 'openvpn.views.add'),    
    (r'^%(model)s/%(object_id)s/?$'         % M, 'openvpn.views.object_detail'),
    (r'^%(model)s/edit/%(object_id)s/?$'    % M, 'openvpn.views.update'),

    (r'^%(model)s/del/%(object_id)s/?$'     % M, 'views.mgeneric.delete_object',
                                                 {'post_delete_redirect' :'/views/close_popup/'}),
    
    
    (r'^%(model)s/ajax/list/?$'             % M, 'openvpn.views.get_search_data'),
    (r'^%(model)s/ajax/del/%(object_id)s/?$'% M, 'openvpn.views.delete_ajax_object'),
    
    (r'^downloads/(?P<cert_name>.*)/$'      % M, 'openvpn.views.download_certificato'),

    (r'^restart_openvpn/?$'                      , 'openvpn.views.restart_openvpn'),  
    (r'^onoff_openvpn/?$'                        , 'openvpn.views.onoff_openvpn'),
)