from jungle.organization.models import *
from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.fax.models import Fax

@login_required
def object_list(request, model, filter_cnd={}, order_by='',
                search_params={}, form=None, **kw):

    if model == 'organization':
        queryset = Organization.objects.all()

    elif model == 'organizationgroup':
        queryset = OrganizationGroup.objects.all()

    elif model == 'organizationform':
        queryset = OrganizationForm.objects.all()

    elif model == 'organizationtype':
        queryset = OrganizationType.objects.all()

    elif model == 'field':
        queryset = Field.objects.all()

    elif model == 'titleperson':
        queryset = TitlePerson.objects.all()

    elif model == 'person':
        queryset = Person.objects.all()

    elif model == 'bank':
        queryset = Bank.objects.all()

    return generic.jobject_list(request, queryset, model, form,
                                filter_cnd, order_by, **kw)

@login_required
def detail(request, model, id):
    model = get_model('organization', model)
    obj = model.objects.filter(pk=id)
    return generic.object_detail(request, queryset=obj, object_id=id, **kw)

#@login_required
#def add(request, model=None, **kw):
#    return generic.create_object(request, model, **kw)

@login_required
def update(request, model=None, **kw):
    kw['extra_context'] = {'mode' : 'update'}
    return generic.update_object(request, model, ext="_update", **kw)

def ajax(request, model):
    from django.http import HttpResponse
    txt = '<ul>'

    queryset = []

    if model == 'organization':
        if request.method == 'POST':
            filter = request.POST.get('autocomplete_organization')
            queryset = Organization.objects.filter(name__icontains = filter)
        for elem in queryset:
            txt += '<li id="%s">%s - %s</li>' % (elem.id, elem.code, elem.name)

    return HttpResponse(txt+'</ul>')
