from django.dispatch import dispatcher
from django.db.models import signals
from jungle.procedure import models
import django.db

create_views = """
    CREATE VIEW
        procedure_totalvatrow_view
            SELECT
                pr.procedure_id::text || '_'::text || pr.vat_id::text AS id,
                pr.procedure_id,
                pr.vat_id,
                SUM(pr.quantity::numeric * pr.price) AS total_income,
                ROUND(SUM(pr.quantity * pr.price * pr.fee / 100)) AS total_fee,
                ROUND(SUM(pr.quantity * pr.price * pr.discount / 100)) AS total_discount,
                ROUND(SUM(pr.quantity * pr.price * (100 + pr.fee - pr.discount) / 100)) AS total,
                ROUND(SUM(pr.quantity * pr.price * (100 + pr.fee - pr.discount) / 100) * v.aliquot_perc / 100, 2) AS total_vat
            FROM
                procedure_procedurerow pr
                JOIN product_vat v ON v.id = pr.vat_id
            GROUP BY
                pr.vat_id, v.aliquot_perc, pr.procedure_id;

    CREATE VIEW
        procedure_total_view AS
            SELECT
                tv.procedure_id AS id,
                tv.procedure_id,
                SUM(tv.total_income) AS total_income,
                SUM(tv.total_fee) AS total_fee,
                SUM(tv.total_discount) AS total_discount,
                SUM(tv.total) AS total,
                SUM(tv.total_vat) AS total_vat
            FROM
                procedure_totalvatrow_view tv
            GROUP BY
                tv.procedure_id;

    CREATE VIEW
        assistance_total_view AS
            SELECT
                ar.assistance_id AS id,
                ar.assistance_id,
                SUM(ar.work_duration) AS work_duration,
                SUM(ar.extra_duration) AS  extra_duration,
                SUM(ar.travel_duration) AS  travel_duration,
                SUM(ar.kilometres) AS  kilometres,
                SUM(CASE WHEN ar.overnight_stay = True THEN 1 ELSE 0 END) AS number_overnight,
                SUM(CASE WHEN ar.pay_exit = True THEN 1 ELSE 0 END) AS number_pay_exit
            FROM
                procedure_assistancerow ar
            GROUP BY
                ar.assistance_id;
"""

def init_data():
    cursor = db.cursor()
try:
    cursor.execute(create_views)
    db.commit()
except:
    pass

dispatcher.connect(init_data, sender=models, signal=signals.post_syncdb)
