from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.procedure.models import Procedure, ProcedureRow, Assistance, AssistanceRow

try:
    LOCATION = settings.LOCATION
except:
    LOCATION = '/'

@login_required
def object_list(request, model, filter_cnd={}, order_by='',
                search_params={}, form=None, **kw):

    if model == 'procedure':
        queryset = Procedure.objects.all()

    if model == 'procedurerow':
        queryset = ProcedureRow.objects.all()

    if model == 'assistance':
        queryset = Assistance.objects.all()

    if model == 'assistancerow':
        queryset = AssistanceRow.objects.all()

    return generic.jobject_list(request, queryset, model, form,
                                filter_cnd, order_by, **kw)

@login_required
def object_detail(request, model, object_id):
    return generic.object_detail(request, model, object_id)

@login_required
def add(request, model=None, **kw):
    if model == 'procedurerow':
        if 'procedure' in request.GET:
            procedure = Procedure.objects.get(pk=request.GET['procedure'])
            kw['extra_context'] = { 'procedure' : procedure, }

    if model == 'assistancerow':
        if 'assistance' in request.GET:
            assistance = Assistance.objects.get(pk=request.GET['assistance'])
            kw['extra_context'] = { 'assistance' : assistance, }

    return generic.create_object(request, model, **kw)

@login_required
def update(request, model=None, **kw):
    return generic.update_object(request, model, ext="_update", **kw)
