from jungle.middleware.thread_local import get_current_user
from jungle.proxy.models import ACL, Category, ACL_Category, IPGroup
from jungle.proxy.models import PERMS
from django import newforms as forms
from django.newforms import ModelForm
from jungle.functions.conf import *
import os, commands

PATH_CAT = get_from_local_settings('PATH_CAT', '/var/lib/squidguard/db')

class CategoryForm(ModelForm):
    class Meta:
        model = Category
    
    def create_db_squidguard(self):
        list = ('my_whitelists/my_white', 'my_blacklists/my_black')
        file_list = ('domains', 'urls')
        
        for l in list:
            for f in file_list:
                path = os.path.join(PATH_CAT, l, f)
                status, output = commands.getstatusoutput("squidGuard -C %s" % path)
        
        
    def save(self):
        cat = super(CategoryForm, self).save()
        self.crea_file_category(cat)
        self.create_db_squidguard()
        return cat
    
    def crea_file_category(self, cat):
        p_domain = os.path.join(PATH_CAT, cat.domain)
        p_url = os.path.join(PATH_CAT, cat.url)
        p_expr = os.path.join(PATH_CAT, cat.expression)
        
        f_domains = open(p_domain, 'w')
        f_urls = open(p_url, 'w')
        f_expressions = open(p_expr, 'w')
        
        f_domains.write(cat.user_domain)
        f_urls.write(cat.user_url)
        f_expressions.write(cat.user_expression)
        
        f_domains.close()
        f_urls.close()
        f_expressions.close()
            
    
class CategoryFormUpdate(CategoryForm):
    def __init__(self, *args, **kwargs):
        self.cat = Category.objects.get(id=args[0]['id'])
        kwargs['instance'] = self.cat
        
        super(CategoryFormUpdate, self).__init__(*args, **kwargs)
            
    def save(self):
        return super(CategoryFormUpdate, self).save()