var NUM_PER_PAGE = 25;
var grid_acl;
    
Ext.onReady(function(){  
    var b_riavvia = new Ext.Button({renderTo:'restart_squid',text:'Riavvia Squid'});
    b_riavvia.on('click', confirm_restart);
    
    var b_onoff = new Ext.Button({renderTo:'endis_squid',text:'Accendi/Spegni Squid'});
    b_onoff.on('click', confirm_onoff);

    var b_onoff_msn = new Ext.Button({renderTo:'endis_msn',text:'Abilita/Disabilita MSN'});
    b_onoff_msn.on('click', confirm_onoff_msn);

    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/proxy/acl/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Gruppo IP\" /></a>");
    }

    function renderDelete(value, p, record){
        return String.format(popup_delete("/proxy/acl/del/"+record.id+"/?popup=true", "Elimina ACL"));
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/acl/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'odv'},
            {name: 'status'},
            {name: 'ip_group'},
            {name: 'time_group'},
            {name: 'category_list'},
            {name: 'default'},
            {name: 'edit'},
            {name: 'delete'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "ODV", width: 10, dataIndex: "odv"},
        {header: "Stato", width: 15, dataIndex: "status",
            editor: new Ext.form.ComboBox({
                typeAhead: true,
                triggerAction: 'all',
                transform:'status',
                lazyRender:true,
                listClass: 'x-combo-list-small'
            })
        },
        {header: "Gruppo", width: 25, dataIndex: "ip_group"},
        {header: "Periodo", width: 25, dataIndex: "time_group"},
        {header: "Categorie", width: 40, dataIndex: "category_list"},
        {header: "Default", width: 25, dataIndex: "default"},
        {header: "", width: 10, align:"center", renderer: renderEdit, 
            dataIndex: 'view_icon'},
        {header: "", width: 10, align:"center", renderer: renderDelete, 
            dataIndex: 'view_icon'}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo ACL {0} - {1} di {2}',
        emptyMsg: "Nessuna ACL da visualizzare"
    });
    
    grid_acl = new Ext.grid.EditorGridPanel({
        el:'grid_acl',
        title:'Lista ACL',        
        width:'83%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar,
        clicksToEdit:1
    });
    
    grid_acl.render();
    
    grid_acl.on('afteredit', updateDB);

    function updateDB(oGrid_Event){
        //update the database
        Ext.Ajax.request(
            { //ajax request configuration  
                waitMsg: 'Saving changes...',
                url: '/proxy/acl/ajax/change_status/', //url to server side script

                params: { //these will be available via $_POST or $_REQUEST:
                    task: "update", //pass task to do to the server script
                    key: 'id',//pass to server same 'id' that the reader used
                    keyID: oGrid_Event.record.data.id,//for existing records this is the unique id (we need this one to relate to the db)
                    //newRecord: isNewRecord,//pass the new Record status indicator to server for special handling
                    field: oGrid_Event.field,//the column name
                    value: oGrid_Event.value,//the updated value
                    originalValue: !oGrid_Event.record.modified
                },//end params

                failure:function(response,options){
                    Ext.MessageBox.alert('Warning','Oops...');
                },//end failure block

                success:function(response,options){
                    //Ext.MessageBox.alert('Success','Yeah...');
                     ds.commitChanges();//commit changes (removes the red triangle which indicates a 'dirty' field)
                     grid_acl.getStore().reload();
                     document.getElementById("message_status").innerHTML = "ATTENZIONE!! RIAVVIARE SQUID PER RENDERE EFFETTIVE LE MODIFICHE";
                }//end success block
             }//end ajax request config
        ); //end ajax request  
    }
        
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/proxy/acl/ajax/list/',
    //                            'grid':grid_acl,
    //                            'button_id':'cerca'});    
});

/*****************************************
 * BOTTONE ABILITA/DISABILITA SQUID
 *****************************************/
function confirm_onoff() {           
    // Show a dialog using config options:
    Ext.Msg.show({
       title:'Attenzione?',
       msg: 'Sei sicuro di voler accendere/spegnere squid?',
       buttons: Ext.Msg.YESNOCANCEL,
       fn: processResultEndis,
       icon: Ext.MessageBox.QUESTION
    }); 
}

function confirm_onoff_msn() {
    // Show a dialog using config options:
    Ext.Msg.show({
       title:'Attenzione?',
       msg: 'Sei sicuro di voler abilitare/disabilitare messenger?',
       buttons: Ext.Msg.YESNOCANCEL,
       fn: processResultEndisMSN,
       icon: Ext.MessageBox.QUESTION
    }); 
}

function processResultEndis(answer){
    if (answer=='yes') {
        Ext.MessageBox.show({
            msg: 'Attendere prego...',
            progressText: 'Accensione/Spegnimento Squid...',
            width: 300,
            wait: true,
            waitConfig: {
                interval: 200
            }
        });
        
        Ext.Ajax.timeout = '200000';
        
        // Call to reload squid
        Ext.Ajax.request({
            url: '/proxy/onoff_squid/',
            success: f_successEndis,
            failure: f_failure
        });     
    }   
}

function processResultEndisMSN(answer){
    if (answer=='yes') {
        Ext.MessageBox.show({
            msg: 'Attendere prego...',
            progressText: 'Abilitazione/Disabilitazione Messenger...',
            width: 300,
            wait: true,
            waitConfig: {
                interval: 200
            }
        });
        
        Ext.Ajax.timeout = '200000';
        
        // Call to reload squid
        Ext.Ajax.request({
            url: '/proxy/onoff_msn/',
            success: f_successEndis,
            failure: f_failure
        });     
    }   
}

/*****************************************
 * BOTTONE AVVIO SQUID
 *****************************************/
function confirm_restart() {
    // Show a dialog using config options:
    Ext.Msg.show({
       title:'Attenzione?',
       msg: 'Sei sicuro di voler riavviare squid?',
       buttons: Ext.Msg.YESNOCANCEL,
       fn: processResultRestart,
       icon: Ext.MessageBox.QUESTION
    }); 
}

function processResultRestart(answer){
    if (answer=='yes') {
        Ext.MessageBox.show({
            msg: 'Attendere prego...',
            progressText: 'Restarting Squid...',
            width: 300,
            wait: true,
            waitConfig: {
                interval: 200
            }
        });
        
        Ext.Ajax.timeout = '200000';
        
        // Call to reload squid
        Ext.Ajax.request({
            url: '/proxy/restart_squid',
            success: f_success,
            failure: f_failure
        });     
    }   
}


function f_successEndis(result){
    if (result.responseText == 'OK') {
        window.location.reload();
        return false;
    }
    else {
        Ext.Msg.show({
            title: 'ERRORE!',
            width: 400,
            msg: result.responseText,
            buttons: Ext.Msg.OK,
            icon: Ext.MessageBox.ERROR
        });        
    }
}

function f_success(result){
    if (result.responseText == 'OK') {
        var title = 'OK!';
        var msg = "Operazione avvenuta con successo.";
        var icon = Ext.MessageBox.INFO;
        document.getElementById("message_status").innerHTML = "";
    }
    else {
        var title = 'ERRORE!';
        var msg = result.responseText;
        var icon = Ext.MessageBox.ERROR;
    }

    Ext.Msg.show({
        title: title,
        width: 400,
        msg: msg,
        buttons: Ext.Msg.OK,
        icon: icon
    });
}

function f_failure(result){
    Ext.Msg.show({
       title:'ERRORE!',
       width: 400,
       msg: "C'e' stato un errore mentre squid si riavviava. Contattare l'amministratore.",
       buttons: Ext.Msg.OK,
       icon: Ext.MessageBox.ERROR
    });
}

function confermaEliminaACL(id_acl){
    ext_confirm = new ExtConfirm({
                    'url': '/proxy/acl/del/' + id_acl,
                    'msgConfirm': "Sei sicuro di voler procedere con la cancellazione dell'ACL??",
                    'progressText': "Cancellazione in corso. Attendere..",
                    'success_msg' : "L'ACL e' stata cancellata correttamente",
                    'post_confirm' : reload_grid
                 });
    ext_confirm.show();
}

function reload_grid() {
    grid_acl.getStore().reload();
}
