var NUM_PER_PAGE = 2000;
var grid_cat;

Ext.onReady(function(){    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        if (value)
            return String.format("<a href='/proxy/category/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Modifica Categoria\" /></a>");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
        
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/category/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'name'},
            {name: 'status'},
            {name: 'type'},
            {name: 'redirect'},
            {name: 'editable'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Nome", width:15, dataIndex: 'name', summaryType: 'count',
            summaryRenderer: function(v, params, data){return 'Totale';}},
        {header: "Stato", width:10, dataIndex: 'status', summaryType: 'count',
            summaryRenderer: function(v, params, data){
                                return ((v === 0 || v > 1) ? v +' Categorie' : '1 Categoria');
                             }},
        {header: "Tipo", width:15, dataIndex: 'type'},
        {header: "Redirect", width:15, dataIndex: 'redirect'},
        {header: "", width: 10, align:"center", renderer: renderEdit, 
            dataIndex: 'editable'}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'type',
        remoteGroup: true        
    });
            
    //ds.setDefaultSort('data_appuntamento', 'DESC');
    
    grid_cat = new Ext.grid.GridPanel({
        el:'grid_category',
        title:'Lista Categorie',
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,

        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),
        
        // bottom toolbars
        bbar: new Ext.PagingToolbar({
            pageSize: NUM_PER_PAGE,
            store: ds,
            displayInfo: true,
            displayMsg: 'Visualizzo categorie {0} - {1} di {2}',
            emptyMsg: "Nessuna categoria da visualizzare"
        }),

        plugins: new Ext.grid.GroupSummary()                

    });
    
    grid_cat.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});

    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/proxy/category/ajax/list/',
    //                            'grid':grid_cat,
    //                            'button_id':'cerca'});        
});