var NUM_PER_PAGE = 25;
var grid_ipgroup;

Ext.onReady(function(){                                        
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/proxy/ipgroup/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Gruppo IP\" /></a>");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/ipgroup/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'odv'},
            {name: 'status'},
            {name: 'name'},
            {name: 'ip_list'},
            {name: 'edit'}            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "ODV", width: 10, dataIndex: "odv"},    
        {header: "Stato", width: 20, dataIndex: "status"},
        {header: "Gruppo", width: 30, dataIndex: "name"},
        {id: 'ip_list', header: "Lista IP", width: 50, dataIndex: "ip_list"},
        {header: "", width:10, align:"center", renderer: renderEdit, 
            dataIndex: 'view_icon', resizable : false}         
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });
    ds.setDefaultSort('odv', 'ASC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Gruppo IP {0} - {1} di {2}',
        emptyMsg: "Nessun Gruppo IP da visualizzare"
    });
    
    grid_ipgroup = new Ext.grid.GridPanel({
        el:'grid_ipgroup',
        title:'Lista Gruppi IP',        
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar
    });
    
    grid_ipgroup.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/proxy/ipgroup/ajax/list/',
    //                            'grid':grid_ipgroup,
    //                            'button_id':'cerca'});    
});