var NUM_PER_PAGE = 25;
var grid_iplist;

Ext.onReady(function(){                                        
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/proxy/iplist/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Gruppo IP\" /></a>");
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/iplist/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'status'},
            {name: 'name'},
            {name: 'ip_list'},
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Stato", width: 20, dataIndex: "status"},
        {header: "Gruppo", width: 30, dataIndex: "name"},
        {header: "Lista IP", width: 50, dataIndex: "ip_list"}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });
    ds.setDefaultSort('name', 'ASC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo IP {0} - {1} di {2}',
        emptyMsg: "Nessun IP da visualizzare"
    });
    
    grid_iplist = new Ext.grid.GridPanel({
        el:'grid_iplist',
        title:'Lista IP',        
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar
    });
    
    grid_iplist.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/proxy/iplist/ajax/list/',
    //                            'grid':grid_iplist,
    //                            'button_id':'cerca'});    
});