var NUM_PER_PAGE = 2000;
var grid_giorni;
    
Ext.onReady(function(){                                           
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderGiorno(value, p, record){
        return String.format("<a href='/proxy/access_log/giorno/"+value+"/'>"+value.substring(6,8)+'/'+value.substring(4,6)+'/'+value.substring(0,4)+"</a>");
    }

    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var filter_by = new Ext.form.ComboBox({
        typeAhead: true,
        triggerAction: 'all',
        renderTo:'filter_by',
        width:135,
        editable: false,
        store: [['d','Oggi'],['w','Ultima Settimana'], ['m','Ultimo Mese'],['y','Ultimo Anno']],
        forceSelection:true
    });
    filter_by.on('select', reload_stat);
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/ajax/report/giorni',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'giorno'},           
            {name: 'n_utenti'},
            {name: 'byte'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Data", width: 30, type: 'date', renderer: renderGiorno, dataIndex: "giorno"},    
        {header: "N. Utenti", width: 50, dataIndex: "n_utenti"},
        {header: "Byte", width: 20, type: "float", 
            renderer: function(v){return Math.round(v*100)/100 + ' Mb';}, dataIndex: "byte"}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;
    
    // create the Data Store
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader
    });

    ds.setDefaultSort('giorno', 'DESC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Giorno {0} - {1} di {2}',
        emptyMsg: "Nessuna Giorno da visualizzare"
    });
    
    grid_giorni = new Ext.grid.GridPanel({
        el:'grid_report_giorni',
        title:'Lista per Giorni',
        width:'83%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar
    });
    
    grid_giorni.render();
	    
    // trigger the data store load
    filter_by.setValue('w');
    reload_stat(filter_by);
    //ds.load({params:{start:0, limit:NUM_PER_PAGE}});
});

function reload_stat(combo, record, index) {
    // Aggiungo la ricerca via Ext
    grid_giorni.getStore().baseParams = {'type': combo.getValue()}
    grid_giorni.getStore().reload();
    //ext_search.search();  
}