var NUM_PER_PAGE = 5000;
var grid_giorni;
    
Ext.onReady(function(){  
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderSito(value, p, record){
        return String.format("<a href='http://"+value+"/' target='_blank'>"+value+"</a>");
    }

    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var URL = '/proxy/ajax/report/giorno/'+giorno+'/'+ip;
   
    var myProxy = new Ext.data.HttpProxy({
        url: URL,
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'last_visit'},
            {name: 'sito'},
            {name: 'num_connessioni'},
            {name: 'elapsed'},
            {name: 'elapsed_m'},
            {name: 'byte'},
            {name: 'client'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Client", width: 20, dataIndex: "client", hidden:true},
        {header: "Sito", width: 40, renderer: renderSito, dataIndex: "sito"},
        {header: "Ultima Visita", width: 40, dataIndex: "last_visit"},
        {header: "Num.Conn", width: 25, summaryType:'sum',
             renderer : function(v, params, data){
                                return ((v === 0 || v > 1) ? v +' Connessioni' : '1 Connessione');
                             }, dataIndex: "num_connessioni"},
        {header: "T.trascorso", width: 15, dataIndex: "elapsed",
            renderer: function(v, p, r){return r.data.elapsed_m;}},
        {header: "Byte", width: 20, type: "float", dataIndex: "byte",
             renderer: function(v){return Math.round(v*100)/100 + ' Mb';}}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;

    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        groupField: 'client',  
        remoteGroup: true             
    });

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Siti {0} - {1} di {2}',
        emptyMsg: "Nessuna Sito da visualizzare"
    });
    
    grid_giorni = new Ext.grid.GridPanel({
        el:'grid_report_giorno',
        title:'Lista',
        width:'83%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),        
        bbar: bbar,
        plugins: new Ext.grid.GroupSummary()
    });
    
    grid_giorni.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
//    ext_search = new ExtSearch({'url':URL,
//                                'grid':grid_giorni,
//                                'button_id':'cerca'});    
});