var NUM_PER_PAGE = 5000;
var grid_giorni;
    
Ext.onReady(function(){  
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderClient(value, p, record){
        return String.format("<a href='/proxy/access_log/ip/"+record.data.client+"'>"+record.data.client+"</a>");
    }

    /***********************
     * END RENDER FUNCTIONS
     ***********************/

    var filter_by = new Ext.form.ComboBox({
        typeAhead: true,
        triggerAction: 'all',
        renderTo:'filter_by',
        width:135,
        editable: false,
        store: [['d','Oggi'],['w','Ultima Settimana'], ['m','Ultimo Mese'],['y','Ultimo Anno']],
        forceSelection:true
    });
    filter_by.on('select', reload_stat);
        
    var URL = '/proxy/ajax/report/ip';
   
    var myProxy = new Ext.data.HttpProxy({
        url: URL,
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'client'},            
            {name: 'connect'},
            {name: 'byte'},
            {name: 'elapsed'},
            {name: 'elapsed_m'},
            {name: 'groupby'}            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "", width: 1, dataIndex: "groupby", hidden: true},    
        {header: "Client", width: 20, renderer: renderClient, dataIndex: "client"},
        {header: "Connect", width: 20, type: "int", summaryType:'sum',
            renderer: function(v, params, data){
                             return ((v === 0 || v > 1) ? v +' Connessioni' : '1 Connessione');
                       }, dataIndex: "connect"},
        {header: "Byte", width: 20, type: "float", 
            renderer: function(v){return Math.round(v*100)/100 + ' Mb';}, dataIndex: "byte"},
        {header: "T.Trascorso", width: 20, dataIndex: "elapsed",
            renderer: function(v, p, r){return r.data.elapsed_m;}}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;

    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        groupField: 'groupby', 
        remoteGroup: true             
    });

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Client {0} - {1} di {2}',
        emptyMsg: "Nessuna Client da visualizzare"
    });
    
    grid_giorni = new Ext.grid.GridPanel({
        el:'grid_report_ip',
        title:'Lista',
        width:'83%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),        
        bbar: bbar,
        plugins: new Ext.grid.GroupSummary()
    });
    
    grid_giorni.render();
	    
    // trigger the data store load
    //ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    filter_by.setValue('w');
    reload_stat(filter_by);
        
    // Aggiungo la ricerca via Ext
//    ext_search = new ExtSearch({'url':URL,
//                                'grid':grid_giorni,
//                                'button_id':'cerca'});    
});

function reload_stat(combo, record, index) {
    // Aggiungo la ricerca via Ext
    grid_giorni.getStore().baseParams = {'type': combo.getValue()}
    grid_giorni.getStore().reload();
    //ext_search.search();  
}