var gridForm;
var ds_grid;

Ext.onReady(function(){
    Ext.QuickTips.init();

    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderClient(value, p, record){
        return String.format("<a href='/proxy/access_log/ip/"+record.data.client+"'>"+record.data.client+"</a>");
    }

    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var URL = '/proxy/ajax/report/ip';
   
    var myProxy = new Ext.data.HttpProxy({
        url: URL,
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'client'},            
            {name: 'connect'},
            {name: 'byte'},
            {name: 'elapsed'},
            {name: 'elapsed_m'},
            {name: 'groupby'}            
        ]
    });
        
    // create the Data Store
    ds_grid = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        groupField: 'groupby', 
        remoteGroup: true             
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "", width: 1, dataIndex: "groupby", hidden: true},    
        {header: "Client", width: 200, renderer: renderClient, dataIndex: "client"},
        {header: "Connect", width: 130, type: "int", summaryType:'sum',
            renderer: function(v, params, data){
                             return ((v === 0 || v > 1) ? v +' Connessioni' : '1 Connessione');
                       }, dataIndex: "connect"},
        {header: "Byte", width: 130, type: "float", 
            renderer: function(v){return Math.round(v*100)/100 + ' Mb';}, dataIndex: "byte"},
        {header: "T.Trascorso", width: 130, dataIndex: "elapsed",
            renderer: function(v, p, r){return r.data.elapsed_m;}}
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;
        
/*
 *	Here is where we create the Form
 */
    gridForm = new Ext.FormPanel({
        id: 'search-form',
        frame: true,
        labelAlign: 'left',
        title: 'Ricerca Accessi',
        bodyStyle:'padding:5px',
        width: 985,
        layout: 'column',	// Specifies that the items will now be arranged in columns
        items: [{
            columnWidth: 0.7,
            layout: 'fit',
            items: {
	            xtype: 'grid',
	            ds: ds_grid,
	            cm: cm,
	            height: 410,
	            title:'Risultati',
	            border: true,
        	}
        },{
        	columnWidth: 0.3,
            xtype: 'fieldset',
            labelWidth: 120,
            title:'Ricerca',
            defaults: {width: 140},	// Default config options for child items
            defaultType: 'textfield',
            autoHeight: true,
            bodyStyle: Ext.isIE ? 'padding:0 0 5px 7px;' : 'padding:10px 7px;',
            border: false,
            style: {
                "margin-left": "10px", // when you add custom margin in IE 6...
                "margin-right": Ext.isIE6 ? (Ext.isStrict ? "-10px" : "-13px") : "0"  // you have to adjust for it somewhere else
            },
            items: [{
                xtype: 'datefield',
                fieldLabel: 'Da (gg/mm/yyyy)',
                format: 'd/m/Y',
                name: 'dataDa'
            },{
                xtype: 'datefield',
                fieldLabel: 'A (gg/mm/yyyy)',
                format: 'd/m/Y',                
                name: 'dataA'
            },{
                fieldLabel: 'IP',
                name: 'ip'
            }],
            buttons: [{
                text: 'Cerca',
                handler: doSearch
            }]            
        }],
        renderTo: 'form_ricerca'
    });
});

function doSearch() {
    gridForm.getForm().submit(
        {
            url:'/proxy/ajax/report/ip', 
            waitMsg:'Ricerca in corso...',
            success: reload_grid,
            failure: failure
         }
    );
}

function reload_grid(form, action) {
    ds_grid.loadData(action.result);
}

function failure(form, action){
    alert("ERROR SEARCHING");
}
