var NUM_PER_PAGE = 25;
var grid_timerule;

Ext.onReady(function(){                                        
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/proxy/timerule/edit/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Regola Tempo\" /></a>");
    }

    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: '/proxy/timerule/ajax/list/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'status'},
            {name: 'name'},
            {name: 'rule_list'},
            {name: 'edit'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Stato", width: 20, dataIndex: "status"},
        {header: "Descrizione", width: 30, dataIndex: "name"},
        {id: 'rules_list', header: "Lista Regole", width: 50, dataIndex: "rule_list"},
        {header: "", width:10, align:"center", renderer: renderEdit, 
            dataIndex: 'view_icon', resizable : false}          
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });
    ds.setDefaultSort('name', 'ASC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Regola tempo {0} - {1} di {2}',
        emptyMsg: "Nessuna Regola Tempo da visualizzare"
    });
    
    grid_timerule = new Ext.grid.GridPanel({
        el:'grid_timerule',
        title:'Lista Regole Tempo',        
        width:'98%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        bbar: bbar
    });
    
    grid_timerule.render();
	    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    
    // Aggiungo la ricerca via Ext
    //ext_search = new ExtSearch({'url':'/proxy/timerule/ajax/list/',
    //                            'grid':grid_timerule,
    //                            'button_id':'cerca'});    
});