#!/usr/bin/python

USAGE ="""
  usage: %prog [options] project
    -s, --settings=py_module: uses py_module as settings module
"""

import os, os.path, sys
import time, datetime
## http://www.linofee.org/~jel/proxy/Squid/accesslog.shtml
import jungle.scripts.optionparse as options
opt, args = options.parse(USAGE)
os.environ['DJANGO_SETTINGS_MODULE'] = opt.settings
#os.environ['DJANGO_SETTINGS_MODULE'] = 'ovpn.settings'
from jungle.proxy.models import Access_Log
from jungle.functions.conf import *
import commands
from jungle.functions import log

filename = get_from_local_settings('FILE_LOG', '/var/log/squid/access.log')

if not os.path.exists(filename):
    sys.exit(0)

status, output = commands.getstatusoutput("logtail -f %s" % (filename,))
lines = []

if output:
    lines = output.split('\n')

ind = 0
d = {} 

for line in lines:
    ind += 1
    fields_list = []
    for field in line.split():
        fields_list.append(field)

    try:
        a,m,g,h,n,s,q,w,e = time.localtime(float(fields_list[0]))
        timestamp = datetime.datetime(a,m,g,h,n)
    except:
        print "ERRORE"
        continue

    elapsed = fields_list[1] ## duration in milleseconds
    client = fields_list[2]
    response_http = fields_list[3]
    action = response_http.split('/')[0]
    code = response_http.split('/')[1]
    size = fields_list[4] ## in bytes
    method = fields_list[5]
    url = fields_list[6]
    try:
        domain_dest = url.split('/')[2]
    except:
        print url
        continue
    #domain_dest = "%s.%s" % (domain_dest.split('.')[-2], domain_dest.split('.')[-1])
    ident = fields_list[7] ## RFC931
    hierarchy  = fields_list[8]
    content = fields_list[9]

    if d.has_key((timestamp, client, code, domain_dest)):
        d[(timestamp, client, code, domain_dest)][5] = d[(timestamp, client, code, domain_dest)][5] + int(size)
    else:
        d[(timestamp, client, code, domain_dest)] = [timestamp, elapsed, client, action,
                                                     code, int(size), method, domain_dest, ident,
                                                     hierarchy, content]
        
            
for key in d.keys():
    timestamp = d[key][0]
    elapsed = d[key][1]
    client = d[key][2]
    action = d[key][3]
    code = d[key][4]
    size = d[key][5]
    method = d[key][6]
    domain_dest = d[key][7]
    ident = d[key][8]
    hierarchy = d[key][9]
    content = d[key][10]
    
    al = Access_Log(
        timestamp = timestamp,
        elapsed = elapsed,
        client = client,
        action = action,
        code = code,
        size = size,
        method = method,
        domain_dest = domain_dest,
        ident = ident,
        hierarchy = hierarchy,
        content = content
    )
    al.save()
    #print fields_list
    #print "***"
    #print "timestamp: %s elapsed: %s client: %s action: %s code: %s size byte: %s method: %s domain dest: %s ident: %s hierarchy: %s content: %s" % (timestamp, elapsed, client, action, code, size, method, domain_dest, ident, hierarchy, content)
