from django.conf.urls.defaults import *

models = 'category|timerule|ipgroup|acl'
default_model = 'acl'
type_report = 'giorni'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>\d+)'
    }

urlpatterns = patterns('jungle',
    (r'^$',                                 'proxy.views.object_list', {'model':default_model}),
    (r'^%(model)s/?$'                       % M, 'proxy.views.object_list'),
    (r'^%(model)s/list/$'                   % M, 'proxy.views.object_list'),
    (r'^%(model)s/add/?$'                   % M, 'proxy.views.add'),    
    (r'^%(model)s/%(object_id)s/?$'         % M, 'proxy.views.object_detail'),
    (r'^%(model)s/edit/%(object_id)s/?$'    % M, 'proxy.views.update'),

    (r'^%(model)s/del/%(object_id)s/?$'     % M, 'views.mgeneric.delete_object',
                 {'post_delete_redirect' :'/views/close_popup/'}),
    
    (r'^%(model)s/ajax/list/?$'             % M, 'proxy.views.get_search_data'),
    (r'^%(model)s/ajax/change_status/?$'    % M, 'proxy.views.change_status'),
    (r'^restart_squid/?$'                  , 'proxy.views.restart_squid'),
    (r'^onoff_squid/?$'                  , 'proxy.views.onoff_squid'),

    (r'^onoff_msn/?$'                  , 'proxy.views.onoff_msn'),

    # REPORT GIORNI URLS
    (r'^access_log/giorni/?$'                  % M, 'proxy.views_report.giorni_list'),
    (r'^access_log/giorno/(?P<data>\d+)/?$'    % M, 'proxy.views_report.giorno_ip_list'),
    (r'^access_log/giorno/(?P<data>\d+)/(?P<ip>.+)/?$'    % M, 'proxy.views_report.giorno_client_list'),

    # REPORT IP URLS
    (r'^access_log/ip/?$'                  % M, 'proxy.views_report.ip_list'),
    (r'^access_log/ip/(?P<ip>.+)/?$'       % M, 'proxy.views_report.ip_client_list'),    

    # REPORT RICERCA
    (r'^access_log/ricerca/?$'             % M, 'proxy.views_report.search'),
    (r'^access_log/check_sito/?$'          % M, 'proxy.views_report.check_sito'),
    (r'^ajax/check_sito/?$'                % M, 'proxy.views_report.ajax_check_sito'),
    
    # REPORT GIORNI AJAX URLS
    (r'^ajax/report/giorni/?$', 'proxy.views_report.report_ajax_giorni'),
    (r'^ajax/report/giorno/(?P<data>\d+)/?$', 'proxy.views_report.report_ajax_giorno_ip'),
    (r'^ajax/report/giorno/(?P<data>\d+)/(?P<ip>.+)/?$', 'proxy.views_report.report_ajax_giorno_client'),

    # REPORT IP AJAX URLS
    (r'^ajax/report/ip/?$', 'proxy.views_report.report_ajax_ip'),
    (r'^ajax/report/ip/(?P<ip>.+)/?$', 'proxy.views_report.report_ajax_ip_client'),   
    
    #MRTG
    (r'^mrtg/?$', 'proxy.views_mrtg.index'),
    (r'^mrtg/(?P<template>.+)?$', 'proxy.views_mrtg.render_template'),
    
    (r'^ajax/report/refresh_report/?$', 'proxy.views_report.refresh_report'),
)
