# -*- coding: utf-8 -*-

from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.proxy.models import Access_Log
from django.utils import simplejson
from django.http import HttpResponse
from django.shortcuts import render_to_response
from django.conf import settings
from datetime import timedelta
#from jungle.functions import log
from jungle.functions.conf import *
from jungle.functions import utils
import time, commands, os
from django.db import connection

MODEL = 'access_log'          

@login_required
def giorni_list(request, **kw):
    return generic.render_template(request, 'proxy/report_giorni.mako', **kw)
    #return generic.jnewobject_list(request, MODEL, **kw)

@login_required
def giorno_ip_list(request, data, **kw):
    kw.update({'data':data})
    return generic.render_template(request, 'proxy/report_giorno_ip.mako', **kw)

@login_required
def giorno_client_list(request, data, ip, **kw):
    kw.update({'data':data, 'ip':ip})
    return generic.render_template(request, 'proxy/report_giorno_client.mako', **kw)

@login_required
def ip_list(request, **kw):
    return generic.render_template(request, 'proxy/report_ip.mako', **kw)
    #return generic.jnewobject_list(request, MODEL, **kw)

@login_required
def ip_client_list(request, ip, **kw):
    kw.update({'ip':ip})
    return generic.render_template(request, 'proxy/report_ip_client.mako', **kw)

@login_required
def search(request, **kw):
    return generic.render_template(request, 'proxy/report_search.mako', **kw)

@login_required
def check_sito(request, **kw):
    return generic.render_template(request, 'proxy/report_check_sito.mako', **kw)

@login_required
def ajax_check_sito(request):
    PROXY_CONF = get_from_local_settings('PATH_PROXY_CONF', '/etc/squid/squidGuard.conf')
    PATH_CAT = get_from_local_settings('PATH_CAT', '/var/lib/squidguard/db')

    post = request.POST
    url_sito = post.get('url_sito', '')
    ip = post.get('ip', '')

    comando = """echo "http://%s %s/ - - GET" | squidGuard -c %s -d"""
    answer = 'Il sito non risulta bloccato per questo IP.'
    
    # Se nn sono stati passati tutti e due i campi ritorno ad ext
    # un messaggio di errore
    #
    if url_sito and ip:
        status, output = commands.getstatusoutput(comando % (url_sito, ip, PROXY_CONF))
        if output.find("squid_ad.html") > -1:
            url_sito = url_sito.replace("www.", "")
            status, answer = commands.getstatusoutput("""grep -R "^%s$" %s""" % (url_sito, PATH_CAT))
            answer = answer.replace(PATH_CAT, '')
            answer = answer.replace('/domains', '')
            answer = answer.replace('/urls', '')
            answer = answer.split('\n')
            answer = '#'.join(answer)
        
    return HttpResponse('{"success": true, "data": "%s"}' % (answer,), mimetype='text/javascript;')


@login_required
def report_ajax_giorni(request):
    tipo = request.GET.get('type', '')

    r = ReportGiorni()
    if settings.DATABASE_ENGINE in ('sqlite', 'sqlite3'):
        sql = r.sql_sqlite(tipo)
    elif settings.DATABASE_ENGINE == 'postgresql_psycopg2':
        sql = r.sql_postgres(tipo)

    cursor = connection.cursor()
    cursor.execute(sql) 
    rs = cursor.fetchall()

    total = len(rs)

    dati = []

    for i, x in enumerate(rs):
        d = {}
        d['id'] = i
        if settings.DATABASE_ENGINE == 'postgresql_psycopg2':
            d['giorno'] = x[0].strftime("%Y%m%d")
        else:
            d['giorno'] = x[0]
        d['n_utenti'] = x[1]
        d['byte'] = float(x[2]) / 1048576.00
        dati.append(d)
        
    data = '{"success": true, "total": %s, "data": %s}' % (total, simplejson.dumps(dati, ensure_ascii=False))
    return HttpResponse(data, mimetype='text/javascript;')

def report_ajax_giorno_ip(request, data):
    r = ReportGiornoIP()
    if settings.DATABASE_ENGINE in ('sqlite', 'sqlite3'):
        sql = r.sql_sqlite()
    elif settings.DATABASE_ENGINE == 'postgresql_psycopg2':
        sql = r.sql_postgres()

    cursor = connection.cursor()
    cursor.execute(sql, (data,))
    rs = cursor.fetchall()

    total = len(rs)

    dati = []
    
    for i, x in enumerate(rs):
        d = {}
        d['id'] = i
        if settings.DATABASE_ENGINE == 'postgresql_psycopg2':
            d['giorno'] = x[0].strftime("%Y%m%d")
        else:
            d['giorno'] = x[0]
        d['client'] = x[1]
        d['connect'] = x[2]
        d['byte'] = float(x[3]) / 1048576.00
        d['elapsed'] = x[4]
        d['elapsed_m'] = utils.get_formatted_time(x[4])
        dati.append(d)
        
    data = '{"success": true, "total": %s, "data": %s}' % (total, simplejson.dumps(dati, ensure_ascii=False))
    return HttpResponse(data, mimetype='text/javascript;')    

@login_required
def report_ajax_giorno_client(request, data, ip):
    r = ReportGiornoClient()
    if settings.DATABASE_ENGINE in ('sqlite', 'sqlite3'):
        sql = r.sql_sqlite()
    elif settings.DATABASE_ENGINE == 'postgresql_psycopg2':
        sql = r.sql_postgres()

    cursor = connection.cursor()
    cursor.execute(sql, (data,ip)) 
    rs = cursor.fetchall()

    total = len(rs)

    dati = []

    for i, x in enumerate(rs):
        d = {}
        d['id'] = i
        d['elapsed'] = x[0]
        d['elapsed_m'] = utils.get_formatted_time(x[0])
        d['byte'] = float(x[1]) / 1048576.00
        d['sito'] = x[2]
        d['num_connessioni'] = x[3]
        d['client'] = "%s - %s/%s/%s" % (x[4], data[6:8], data[4:6], data[0:4])
        d['last_visit'] = x[5].strftime("%d/%m/%Y %H:%M")
        dati.append(d)
        
    data = '{"success": true, "total": %s, "data": %s}' % (total, simplejson.dumps(dati, ensure_ascii=False))
    return HttpResponse(data, mimetype='text/javascript;')  

@login_required
def report_ajax_ip(request):
    tipo = request.GET.get('type', '')
    data_da = request.POST.get('dataDa', '')
    data_a = request.POST.get('dataA', '')
    ip = request.POST.get('ip', '')
    where = ""

    r = ReportAjaxIP()
    if settings.DATABASE_ENGINE in ('sqlite', 'sqlite3'):
        sql = r.sql_sqlite(tipo, data_da, data_a, ip)
    elif settings.DATABASE_ENGINE == 'postgresql_psycopg2':
        sql = r.sql_postgres(tipo, data_da, data_a, ip)

    cursor = connection.cursor()
    cursor.execute(sql)
    rs = cursor.fetchall()
    total = len(rs)

    dati = []

    for i, x in enumerate(rs):
        d = {}
        d['id'] = i
        d['groupby'] = x[0]
        d['client'] = x[1]
        d['connect'] = x[2]
        d['elapsed'] = x[3]
        d['elapsed_m'] = utils.get_formatted_time(x[3])
        d['byte'] = float(x[4]) / 1048576.00
        dati.append(d)
    
    data = '{"success": true, "total": %s, "data": %s}' % (total, simplejson.dumps(dati, ensure_ascii=False))
    return HttpResponse(data, mimetype='text/javascript;')

@login_required
def report_ajax_ip_client(request, ip):
    r = ReportIPClient()
    if settings.DATABASE_ENGINE in ('sqlite', 'sqlite3'):
        sql = r.sql_sqlite()
    elif settings.DATABASE_ENGINE == 'postgresql_psycopg2':
        sql = r.sql_postgres()

    cursor = connection.cursor()
    cursor.execute(sql, (ip,))
    rs = cursor.fetchall()

    total = len(rs)

    dati = []
    
    for i, x in enumerate(rs):
        d = {}
        if settings.DATABASE_ENGINE == 'postgresql_psycopg2':
            d['giorno'] = x[0].strftime("%Y%m%d")
        else:
            d['giorno'] = x[0]
        d['client'] = x[1]
        d['connect'] = x[2]
        d['byte'] = float(x[3]) / 1048576.00
        d['elapsed'] = x[4]
        d['elapsed_m'] = utils.get_formatted_time(x[4])
        dati.append(d)

    data = '{"success": true, "total": %s, "data": %s}' % (total, simplejson.dumps(dati, ensure_ascii=False))
    return HttpResponse(data, mimetype='text/javascript;')

def refresh_report(request):
    status, output = commands.getstatusoutput("logs_reader -s ovpn.settings")
    return HttpResponse('OK', mimetype='text/javascript;')

class ReportGiorni(object):
    def sql_sqlite(self, tipo):
        where = ""
        
        if tipo == 'd':
            where = """WHERE STRFTIME("%%Y%%m%%d",timestamp) = STRFTIME("%%Y%%m%%d", datetime('now', 'localtime'))"""
        elif tipo == 'w':
            where = """WHERE STRFTIME("%%W%%Y",timestamp) = STRFTIME("%%W%%Y", datetime('now', 'localtime'))"""
        elif tipo == 'm':
            where = """WHERE STRFTIME("%%m%%Y",timestamp) = STRFTIME("%%m%%Y", datetime('now', 'localtime'))"""
        elif tipo == 'y':
            where = """WHERE STRFTIME("%%Y",timestamp) = STRFTIME("%%Y", datetime('now', 'localtime'))"""

        sql = """ 
              SELECT
                  TC.giorno,
                  COUNT(TC.client) AS n_utenti,
                  SUM(TC.total)
              FROM 
                  (
                  SELECT
                      client, STRFTIME("%%%%Y%%%%m%%%%d",timestamp) AS giorno, SUM(size) AS total
                  FROM 
                      proxy_access_log
                  %s
                  GROUP BY
                      strftime("%%%%Y%%%%m%%%%d",timestamp), client
                   ) AS TC
              GROUP BY
                  TC.giorno
                """ 

        sql = sql % where
        return sql

    def sql_postgres(self, tipo):
        where = ""
        
        if tipo == 'd':
            where = """WHERE date_trunc('day', timestamp) = date_trunc('day', current_date)"""
        elif tipo == 'w':
            where = """WHERE date_trunc('week', timestamp) = date_trunc('week', current_date)"""
        elif tipo == 'm':
            where = """date_trunc('month', timestamp) = date_trunc('month', current_date)"""
        elif tipo == 'y':
            where = """date_trunc('year', timestamp) = date_trunc('year', current_date)"""

        sql = """ 
              SELECT
                  TC.giorno,
                  COUNT(TC.client) AS n_utenti,
                  SUM(TC.total)
              FROM 
                  (
                  SELECT
                      client, date_trunc('day', timestamp) AS giorno, SUM(size) AS total
                  FROM 
                      proxy_access_log
                  %s
                  GROUP BY
                      date_trunc('day', timestamp), client
                   ) AS TC
              GROUP BY
                  TC.giorno
                """ 

        sql = sql % where
        return sql

class ReportGiornoIP(object):
    def sql_sqlite(self):
        sql = """ SELECT
                      strftime("%%d/%%m/%%Y",timestamp) AS giorno, client, 
                      COUNT(domain_dest) AS connect, SUM(size) AS size, SUM(elapsed) AS elapsed
                  FROM proxy_access_log
                  WHERE strftime("%%Y%%m%%d",timestamp) = %s
                  GROUP BY strftime("%%d/%%m/%%Y",timestamp), client
                  ORDER BY COUNT(domain_dest) DESC
                """
        return sql

    def sql_postgres(self):
        sql = """ SELECT
                      date_trunc('day', timestamp) AS giorno, client, 
                      COUNT(domain_dest) AS connect, SUM(size) AS size, SUM(elapsed) AS elapsed
                  FROM proxy_access_log
                  WHERE date_trunc('day', timestamp) = %s
                  GROUP BY date_trunc('day', timestamp), client
                  ORDER BY COUNT(domain_dest) DESC
                """
        return sql

class ReportGiornoClient(object):
    def sql_sqlite(self):
        sql = """ SELECT sum(elapsed) as tempo, sum(size) as size, 
                         domain_dest, count(domain_dest), client, timestamp
                  FROM proxy_access_log
                  WHERE
                    strftime("%%Y%%m%%d",timestamp) = %s
                    and client = %s
                  GROUP BY domain_dest, client
                  ORDER BY count(domain_dest) DESC, domain_dest
                """
        return sql

    def sql_postgres(self):
        sql = """ SELECT sum(elapsed) as tempo, sum(size) as size, 
                         domain_dest, count(domain_dest), client, max(timestamp)
                  FROM proxy_access_log
                  WHERE
                    date_trunc('day', timestamp) = %s
                    and client = %s
                  GROUP BY domain_dest, client
                  ORDER BY count(domain_dest) DESC, domain_dest
                """
        return sql


class ReportAjaxIP(object):
    def sql_sqlite(self, tipo, data_da, data_a, ip):
        if tipo:
            if tipo == 'd':
                where = """WHERE STRFTIME("%%Y%%m%%d",timestamp) = STRFTIME("%%Y%%m%%d", datetime('now', 'localtime'))"""
            elif tipo == 'w':
                where = """WHERE STRFTIME("%%W%%Y",timestamp) = STRFTIME("%%W%%Y", datetime('now', 'localtime'))"""
            elif tipo == 'm':
                where = """WHERE STRFTIME("%%m%%Y",timestamp) = STRFTIME("%%m%%Y", datetime('now', 'localtime'))"""
            elif tipo == 'y':
                where = """WHERE STRFTIME("%%Y",timestamp) = STRFTIME("%%Y", datetime('now', 'localtime'))""" 
        else:
            if data_da or data_a or ip:
                where += "WHERE 1=1"
            if data_da:
                data_da = utils.get_formatted_date(data_da)
                where += """ AND STRFTIME("%%%%Y%%%%m%%%%d",timestamp) >= '%s' """ % data_da
            if data_a:
                data_a = utils.get_formatted_date(data_a)
                where += """ AND STRFTIME("%%%%Y%%%%m%%%%d",timestamp) <= '%s' """ % data_a
            if ip:
                where += " AND client = '%s'" % ip

        sql = """select 'client', client, count(*) as tot_connessioni, 
                        sum(elapsed) as t_time, sum(size) as t_byte
                  from proxy_access_log
                  %s
                  group by client 
                  order by client"""
        sql = sql % where
        return sql

    def sql_postgres(self, tipo, data_da, data_a, ip):
        if tipo:
            if tipo == 'd':
                where = """WHERE date_trunc('day', timestamp) = date_trunc('day', current_date)"""
            elif tipo == 'w':
                where = """WHERE date_trunc('week', timestamp) = date_trunc('week', current_date)"""
            elif tipo == 'm':
                where = """WHERE date_trunc('month', timestamp) = date_trunc('month', current_date)"""
            elif tipo == 'y':
                where = """WHERE date_trunc('year', timestamp) = date_trunc('year', current_date)""" 
        else:
            if data_da or data_a or ip:
                where += "WHERE 1=1"
            if data_da:
                data_da = utils.get_formatted_date(data_da)
                where += """ AND date_trunc('day', timestamp) >= '%s' """ % data_da
            if data_a:
                data_a = utils.get_formatted_date(data_a)
                where += """ AND date_trunc('day', timestamp) <= '%s' """ % data_a
            if ip:
                where += " AND client = '%s'" % ip

        sql = """select 'client', client, count(*) as tot_connessioni, 
                        sum(elapsed) as t_time, sum(size) as t_byte
                  from proxy_access_log
                  %s
                  group by client 
                  order by client"""
        sql = sql % where
        return sql

class ReportIPClient(object):
    def sql_sqlite(self):
        sql = """select strftime("%%Y%%m%%d",timestamp) as giorno, client, 
                count(domain_dest) as connect, sum(size) as size, sum(elapsed) as elapsed
                from proxy_access_log
                where client = %s
                group by client, strftime("%%Y%%m%%d",timestamp)
                order by strftime("%%Y%%m%%d",timestamp) DESC
                """
        return sql

    def sql_postgres(self):
        sql = """select date_trunc('day', timestamp) as giorno, client, 
                count(domain_dest) as connect, sum(size) as size, sum(elapsed) as elapsed
                from proxy_access_log
                where client = %s
                group by client, date_trunc('day', timestamp)
                order by date_trunc('day', timestamp) DESC
                """
        return sql
