from django.utils import simplejson
from django.http import HttpResponse
from jungle.views.decorators import login_required
from jungle.ref.models import Province, Region, BankABI, BankCAB

# Create your views here.
@login_required
def ajax(request, model):
    searched_field = request.GET.get('query')
    if model == 'province':
        queryset = Province.objects.filter(name__istartswith = searched_field)
        def crea_diz(x):
            return {'id_data': x.code, 'code': x.code, 'name': x.name,}

    if model == 'bank_abi':
        queryset = BankABI.objects.filter(code_ABI__startswith = searched_field).filter(status = 1)
        def crea_diz(x):
            return {'id_data': x.code_ABI, 'code_ABI': x.code_ABI, 'name_bank': x.name_bank,}

    if model == 'bank_cab':
        queryset = BankCAB.objects.filter(code_CAB__startswith = searched_field).filter(status = 1)
        def crea_diz(x):
            return {'id_data': x.code_CAB, 'code_CAB': x.code_CAB, 'name_office': x.name_office,}

    total = queryset.count()
    dati = [crea_diz(x) for x in queryset]
    data = '{"totalCount": "%s", "datas": %s}' % (total, simplejson.dumps(dati))
    return HttpResponse(data, mimetype='text/javascript;')