from django.db import models 
from django.contrib.auth.models import User 
from jungle.functions.tools import app_contrib_from_settings, app_in_settings
      
class UserProfile(models.Model): 
    # user = models.ForeignKey(User, unique=True, edit_inline=models.TABULAR,
    # num_in_admin=1,min_num_in_admin=1, core=True,
    # max_num_in_admin=1,num_extra_on_change=0) 
    user = models.OneToOneField(User) 
    nick = models.CharField(max_length=15, blank=True, null=True) 
    url = models.URLField(blank=True, null=True) 
    phone_number = models.CharField(max_length=15, blank=True, null=True) 
    mobile_number = models.CharField(max_length=15, blank=True, null=True) 
    ## fields for registration
    activation_key = models.CharField(max_length=40, blank=True, null=True) 
    key_expires = models.DateTimeField(blank=True, null=True) 

    if app_in_settings('jungle.apps.timereport'):
        from jungle.timereport.models import TimetableProfile
        badge_num = models.IntegerField(blank=True, null=True)
        time_profile = models.ForeignKey(TimetableProfile, blank=True, null=True)

    def __unicode__(self):
        return unicode(self.user)
                   
    class Meta:
        db_table = "auth_user_profile"

    class Admin: pass
