from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from jungle.store.models import Store, StoreDocument, StoreCause

try:
    LOCATION = settings.LOCATION
except:
    LOCATION = '/'

@login_required
def object_list(request, model, filter_cnd={}, order_by='',
                search_params={}, form=None, **kw):

    if model == 'store':
        queryset = Store.objects.all()

    elif model == 'storedocument':
        queryset = StoreDocument.objects.all()

    elif model == 'storecause':
        queryset = StoreCause.objects.all()

    return generic.jobject_list(request, queryset, model, form,
                                filter_cnd, order_by, **kw)

@login_required
def object_detail(request, model, object_id):
    return generic.object_detail(request, model, object_id)

@login_required
def add(request, model=None, **kw):
    return generic.create_object(request, model, **kw)

@login_required
def update(request, model=None, **kw):
    return generic.update_object(request, model, ext="_update", **kw)
