from jungle.templatetags import fast_search
from jungle.ticket.models import Project
from django.contrib.auth.models import User
from jungle.templatetags.jungle_tags import ugettext as _


class FSOpts(fast_search.FSOpts):

    def formfield_project(self, field, initial=None, defaults=None):
        return self.choices(Project.my_objects.all())
 
    def formfield_submitter(self, field, initial=None, defaults=None):
        projects = [p.id for p in Project.my_objects.all()]
        people = User.objects.filter(project__in=projects).distinct()
        return self.choices(people)
 
    def formfield_assigned_to(self, field, initial=None, defaults=None):
        projects = [p.id for p in Project.my_objects.all()]
        people = User.objects.filter(project__in=projects).distinct()
        return self.choices(people)
 
    def formfield_submitter_(self, field, initial=None, defaults=None):
        return self.choices(User.objects.filter(id=self.user.id))

    
