var myForm; // Form di appoggio per la stampa degli appuntamenti
var NUM_PER_PAGE = 10000; // Numero di righe visualizzate in ogni pagina della griglia
var grid;

Ext.onReady(function(){      
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    function renderEdit(value, p, record){
        return String.format("<a href='/ticket/ticket/"+record.id+"/'><img src='/static/img/edit.gif' title=\"Modifica Appuntamento\" /></a>");
    }

    function renderDate(value, p, record){
        return String.format("<b>"+Ext.util.Format.date(value, 'd/m/Y H:i')+'</b>');
    }

    function renderBold(value, p, record){
        return String.format("<b>"+value+'</b>');
    }
    
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var pr_id = Ext.get('project_id').getValue()
    var myProxy = new Ext.data.HttpProxy({
        url: '/ticket/project/'+ pr_id + '/ajax/list_ticket/',
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'data_creazione'},
            {name: 'priority'},
            {name: 'submitter'},
            {name: 'titolo'},
            {name: 'progetto'},
            {name: 'category'},
            {name: 'assigned_by'},
            {name: 'assigned_to'},
            {name: 'status'},
            {name: 'data_ultima_mod'}
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Date Create", width:18, renderer: Ext.util.Format.dateRenderer('d/m/Y'), 
            dataIndex: 'data_creazione', summaryType: 'max',
            summaryRenderer: function(v, params, data){return 'Totale';}},

        {header: "Priorita'", width:20, align:"center", dataIndex: 'priority', summaryType: 'count', 
            summaryRenderer: function(v, params, data){
                                return ((v === 0 || v > 1) ? v +' Ticket' : '1 Ticket');
                             }, sortable:true},
                     
        {header: "Notificato da", width:15, dataIndex: 'submitter'},
                                              
        {header: "Titolo", width:45, dataIndex: 'titolo'},
        
        {header: "Progetto", width:20, dataIndex: 'progetto'},
        
        {header: "Categoria", width:20, dataIndex: 'category', sortable:true},
        
        {header: "Assegnato da", width:18, dataIndex: 'assigned_by'},
        
        {header: "Assegnato a", width: 18, dataIndex: 'assigned_to', sortable:true},

        {header: "Stato", width: 15, dataIndex: 'status', sortable:true},
                
        {header: "<b>M</b>", width:10, align:"center", renderer: renderEdit, 
            dataIndex: 'view_icon', resizable : false}            
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = false;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'priority',
        remoteGroup: true,
        baseParams: {}
    });
    
    ds.setDefaultSort('priority', 'ASC');
    
    grid = new Ext.grid.GridPanel({
        el:'ticket_list',
        title:'Lista Ticket',        
        width:'100%',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
                
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),

        // bottom toolbars
        bbar: new Ext.PagingToolbar({
            pageSize: NUM_PER_PAGE,
            store: ds,
            displayInfo: true,
            displayMsg: 'Visualizzo ticket {0} - {1} di {2}',
            emptyMsg: "Nessun ticket da visualizzare"
        }),
                
        plugins: new Ext.grid.GroupSummary()        
    });
    
    grid.render();

    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});

});