from django.test.client import Client
from jungle.tests import NoFixtures, WithFixtures
from django.contrib.contenttypes.models import ContentType
from jungle.ticket.models import Ticket

package = Ticket._meta.app_label
module  = Ticket._meta.module_name
content_type = ContentType.objects.get(
                   app_label__exact=package,model__exact=module)

POST_ADD = (
    ('/ticket/project/add/', dict(name='Dummy Project', description='line 1\nline 2\nline 3\n',
                                  organization=1, manager=1, staff=1, date_start='2007-06-19',
                                  date_end='2007-6-30', status=0)),

    ('/ticket/ticket/add/', dict(title='Dummy Fix Ticket', assigned_to=1, project=1,
                                 keywords='one two three', description='line 1\nline 2\nline 3\n',
                                 priority=3, category='fix', status=1, submitter=1)),

    ('/ticket/ticket/comment/1/%s/' % content_type.id, dict(comment='Thunder Comment',
                                      content_type=content_type.id, object_id=1, person_name='test',
                                      is_public=1, approved=1, ip_address='127.0.0.1', site=1)),
    )

GET = (
    '/ticket/project/add/',
    '/ticket/ticket/add/',
    '/ticket/project/1/',
    '/ticket/ticket/1/',
    )

LOGIN_REQUIRED = (
    ('/ticket/ticket/', {}),
    ('/ticket/ticket/add/', {}),
    ('/ticket/project/', {}),
    ('/ticket/project/add/', {}),
    ('/ticket/ticket/1/', {}),
    ('/ticket/project/1/', {}),
    )

#class Menu(NoFixtures):
#    app_label = 'ticket'
#    login_required = LOGIN_REQUIRED
#    data = 'test_organization.json'
#    post_get = POST_ADD

class Test(WithFixtures):
    fixtures = ['test_organization.json', 'test_ticket.json']
    post_get = POST_ADD
    get = GET
