from django.newforms import ModelForm
#from jungle.db.formfield import ffc
from django.newforms.models import form_for_model

from jungle.ticket.models import Ticket
from django import newforms as forms
from jungle.functions.utils import Dict2Obj
from django.contrib.auth.models import User
from models import Project

class TicketForm(ModelForm):
    class Meta:
        model = Ticket

    def __init__(self, *args, **kwargs):
        super(TicketForm, self).__init__(*args, **kwargs)
        self.fields['add_to_staff'] = forms.fields.BooleanField(
            required=False)
        self.fields['project'].widget.choices = get_projects()

    def clean_(self):
        self.cd = Dict2Obj(self.cleaned_data)
        if self.cd.assigned_to is None:
            raise forms.ValidationError("manca assegnatario")

    def save(self):
        return super(TicketForm, self).save()
        

def get_projects():
    yield ('', '-' * 8)
    for job in Project.my_objects.filter(status=1).order_by('name'):
        yield (job.id, job.name)
