#!/bin/env python

import jungle.scripts.optionparse as options

USAGE ="""
  usage: %prog [options] project
    -n, --dry-run: just show - don't update db
    -v, --verbose: print warnings (default behaviour)
    -q, --quite: don't print warnings
"""


opts, args = options.parse(USAGE)

import os, sys
os.environ['DJANGO_SETTINGS_MODULE'] = args[0]

from jungle.timereport.models import *
from datetime import *

def fix_qty(entry):
    """fix entry with qty -1 to fill the time that is not yet allocated
    """
    allocated = Report.get_allocated(entry.user.id, entry.date)
    worked = Transit.get_worked(entry.user, entry.date)
    missing = worked - allocated
    h, m = divmod(missing.seconds/60,  60)
    entry.qty = h*100 + m
    if opts.dry_run:
        print vars(entry)
    else:
        entry.save()

queryset = Report.objects.filter(qty = -100).select_related()
for entry in queryset:
    fix_qty(entry)


    
