from django.newforms.models import form_for_model
from jungle.db.formfield import ffc
from jungle.registration.models import UserProfile
from jungle.timereport.models import Transit
from jungle.timereport.badges import setup, add_transit
from django.newforms.util import ValidationError
from datetime import datetime

class TransitBasicForm(form_for_model(Transit, formfield_callback=ffc())):

    def __init__(self, *args, **kwargs):
        super(TransitBasicForm, self).__init__(*args, **kwargs)
        self['badge_num'].field.required = True
        self['date_reference'].field.required = False

    def clean(self):
        self.cleaned_data['date_time'] = datetime.now()

        try:
            int(self.cleaned_data['badge_num'])
        except:
            raise ValidationError(u"Badge n. must be an integer.")
        try:
            UserProfile.objects.get(badge_num = self.cleaned_data['badge_num'])
        except:
            raise ValidationError(
                  u"Badge n. %s does not have a related profile" \
                  % self.cleaned_data['badge_num'])
        self.cleaned_data['user'] = UserProfile.objects.get(badge_num = self.cleaned_data['badge_num']).user

        return self.cleaned_data

    def save(self):
        error_line = u"Error found saving Badge n. %s" \
                       % self.cleaned_data['badge_num']
        setup()
        tr = add_transit(error_line, self.cleaned_data)

        return tr
