from django.conf.urls.defaults import *


models = 'transit|timetableprofile|timetableprofiledetail|reason|vacation|iter|report'
default_model = 'transit'

M = {
    'model'     : '(?P<model>%s)' % models,
    'object_id' : '(?P<object_id>[a-zA-Z0-9]+)',  #may be code
    'user_id'   : '(?P<user_id>\d+)',
    'odv'       : '(?P<odv>\d+)',
    'date'       : '(?P<date>[\d/]+)',
    }



urlpatterns = patterns('jungle',
    (r'^$',                      'timereport.views.object_list',
        {'model':default_model}
    ),
    (r'^(?P<model>report)/join/$'  ,            'timereport.views.join'),
    (r'^report/edit/(?P<user_id>\d+)/(?P<date>.+)/$', 'timereport.views.update_report'),
    (r'^report/day/(?P<user_id>\d+)/(?P<date>.+)/$', 'timereport.views.report_day_detail'),
    (r'^(?P<model>report)/join/$'  ,            'timereport.views.join'),
    (r'^generic/', 'timereport.views.list_view', {'model':
                                                             'timetableprofile'}),                      
    #(r'^%(model)s/oldedit/%(object_id)s/?$' % M,    'timereport.views.old_update'),
    (r'^%(model)s/edit/%(object_id)s/?$' % M,       'timereport.views.update'),
    (r'^%(model)s/del/%(object_id)s/?$'  % M,       'views.mgeneric.delete_object',
     {'template_name': '/delete_confirmation_popup.mako',
      'post_delete_redirect' :'/views/close_popup/'}),
    (r'^(?P<model>iter)/?$'  % M,                         'timereport.views.add'),
    (r'^%(model)s/?$'  % M,                         'timereport.views.object_list'),
    (r'^%(model)s/list/$'  % M,                     'timereport.views.object_list'),
    #(r'^%(model)s/show/(?P<period>week|month)/(?P<emploee>\d*)$'  % M, 'timereport.views.employee_view'),
    (r'^%(model)s/add/?$'  % M,                     'timereport.views.add'),

    #(r'^%(model)s/add/%(user_id)s/?$'  % M,                     'timereport.views.add'),
    (r'^%(model)s/add/%(user_id)s/%(odv)s/%(date)s?$'  % M, 'timereport.views.add'),

    #(r'^%(model)s/comment/(?P<object_id>\d+)/(?P<content_type>\d+)/?$'  % M,
    #                                                'timereport.views.add_comment'
    #),
    (r'^%(model)s/%(object_id)s/$'  % M,            'timereport.views.object_detail'),
    (r'^iter/approve/(?P<level>[12])/(?P<object_id>\d+)/$'  % M,            'timereport.views.approve'),
    (r'^close/?$' %M,                       'views.mgeneric.close_popup'),
    
    # add a Transit via form
    (r'^transit/add_form/?$',                       'timereport.views.add_transit_via_form'),
)

