from django.conf import settings
from jungle.views.decorators import login_required
from jungle.views import mgeneric as generic
from models import *
from profile_form import get_day_details
from django.template import RequestContext
import datetime
from django.http import HttpResponse, HttpResponseRedirect
from django.contrib.auth.models import User
import decimal
from jungle.template import mako_loader
from jungle.templatetags.jungle_tags import ugettext as _

def list_view(request, model):
    """this is just a test. I needed a test with django templates
    you get here with /timereport/generic/
    """
    
    queryset = TimetableProfile.objects.all()
    from django.views.generic import list_detail
    return list_detail.object_list(request, queryset=queryset, extra_context={'abc' : 'ABC'})

@login_required
def object_list(request, model, filter_cnd=None, order_by='-date_create',
                form=None, **kw):
    if not filter_cnd:
        filter_cnd = {}

    import time_display 

    if model in ('transit', 'vacation'):
        if request.user.is_staff:
            queryset = Transit.objects.all().select_related()
        else:
            queryset = Transit.objects.filter(user=request.user).select_related()

        if model == 'vacation':
            #filter_cnd['']
            model = 'transit'
            user_precedence = True
        from jungle.views.fast_search import search2
        if 'from' not in request.GET:
            filter_cnd['from'] = 'd'
            filter_cnd['to'] = 'd+1'

        filter_cnd, order_by, form =  search2(
            request, model, order_by = order_by, extra_filter=filter_cnd,
            extra_context={'user_precedence' : 'user_precedence' in vars()}, **kw)

        T , Days, Users, Totals, PeriodTotals = time_display.get_transits(
            filter=filter_cnd, queryset=queryset)
        
        kw['extra_context'] = {'T' : T, 'Days' : Days, 'Users' : Users,
                           'user_precedence' : 'user_precedence' in vars(),
                           'Totals' : Totals, 'PeriodTotals': PeriodTotals}

        if 'Report' in request.GET:
            return cvs_report(T, Days, Users, Totals, PeriodTotals, mode='short')

        elif 'LongReport' in request.GET:
            return cvs_report(T, Days, Users, Totals, PeriodTotals, mode='long')

        elif 'DbReport' in request.GET or 'Commercialista' in request.GET:
            return db_report(request, T, Days, Users, Totals, PeriodTotals, mode='db')
            
#         elif 'Commercialista' in request.GET:
#             return cvs_report(T, Days, Users, Totals, PeriodTotals, mode='comm')
            

#         return render_to_response('timereport/transit_list.mako',
#                                   dictionary = extra_context,
#                                   context_instance=RequestContext(request),
#                                   )

    elif model == 'timetableprofile':
        queryset = TimetableProfile.objects.all()

    elif model == 'reason':
        queryset = Reason.objects.all()
        order_by = 'code'

    elif model == 'final':
        queryset = Final.objects.all()
        order_by = 'user'

    elif model == 'iter':
        queryset = Iter.objects.all()
#         if not request.user.is_staff:
#             queryset = queryset.filter(user=request.user)
        order_by = 'date_start'

    elif model == 'report':

        if 'from' not in request.GET:
            filter_cnd['from'] = 'd-2'
        queryset = Report.objects.exclude(qty=0)
        order_by = 'date'

        if not request.user.is_staff:
            queryset = queryset.filter(user=request.user)

    return generic.jobject_list(request, queryset, model, form,
                                filter_cnd, order_by, **kw)


@login_required
def add(request, model=None, user_id=None, odv=None, date=None, **kw):
    form = None

    if model == 'timetableprofile':
        from profile_form import ProfileForm
        kw['extra_context'] = {'names': get_week_day_names()}
        return generic.create_object(request, model, form=ProfileForm, **kw)

    if model == 'transit':
        
        if user_id:
            ## this happens when you want to add a missing data from the general view
            ## you really want to specify only the time. All the rest is already
            ## decided unless you have two 'missing' in the same turn.

            from django.contrib.auth.models import User
            from jungle.registration.models import UserProfile
            from transit_form import TransitForm
            
            u = User.objects.get(pk=user_id)
            profile = UserProfile.objects.get(user=u)
            date = datetime.date(*[int(x) for x in date.strip('/').split('/')])
            
            isoweekday = date.isoweekday()
            if 'extra_context' not in kw:
                kw['extra_context'] = {}

            nodv = int(odv)
            if not nodv % 2:
                nodv = nodv -1

            detail = profile.time_profile.timetableprofiledetail_set.get(
                odv=nodv, isoweekday=isoweekday)
            
            ## if we have another transit the same (half) day we redirect to
            ## vacation/add so that more trasits are added at once

            ## problemi con $?next_url in vacation_form: elimino questo pezzo

            try:
                if not int(odv) % 2: # pari
                    j = nodv
                else:
                    j = nodv + 1
                  
                  
                t = Transit.objects.get(date_reference=date, odv=j,user=u)
            except:
                return HttpResponseRedirect(
                    '/timereport/iter/add/?popup=1&next_url=/views/close_popup/')

            kw['extra_context']['transit_user'] = u
            kw['extra_context']['profile'] = profile
            kw['extra_context']['isoweekday'] = isoweekday
            kw['extra_context']['odv'] = int(odv)
            kw['extra_context']['direction'] = (int(odv)%2)
            kw['extra_context']['date'] = date.strftime('%d/%m/%Y')
            kw['extra_context']['detail'] = detail
            form = TransitForm

            
        if request.GET and request.GET['mode'] == 'short':
            kw['template_name'] = 'timereport/transit_form_popup.mako'
            kw['post_save_redirect'] = '%stimereport/close/' % settings.LOCATION

    if model == 'iter':
        model = 'transit'
        from vacation_form import VacationForm
        form = VacationForm
        kw['template_name'] = 'timereport/vacation_form.mako'
        kw['post_save_redirect'] = '%stimereport/iter/%%(id)s/' % settings.LOCATION
        #import pdb ; pdb.set_trace()
        if 'next_url' in request.POST and request.POST['next_url']:
            kw['post_save_redirect'] = '/views/close_popup/'
        
    if model == 'report':
        from report_form import ReportForm
        class JobReportForm(ReportForm):
            user = request.user
        
        form = JobReportForm
        kw['template_name'] = '/timereport/report_day_form.mako'
        kw['post_save_redirect'] = '/timereport/report/day/%(user)s/%(date)s/'
        
    return generic.create_object(request, model, form=form, **kw)

@login_required
def update(request, model=None, object_id=None, **kw):

    if model == 'transit':
        from transit_basic_form import TransitBasicForm
        kw['post_save_redirect'] = '%stimereport/close/' % settings.LOCATION            
        form = TransitBasicForm

    if model == 'timetableprofile':
        from profile_form import ProfileForm
        #data = vars(TimetableProfile.objects.get(pk=object_id))
        #data.update(get_day_details(object_id))
        kw['extra_context'] = {
            'mode' : 'update',
            'names': get_week_day_names(),
            }
        return generic.update_object(request, model, object_id, ext="_update",
                                         form=ProfileForm, **kw)
    

    return generic.update_object(request, model, object_id, ext="_update",**kw)
                                 

@login_required
def update_report(request, user_id, date):
    from report_form import ReportForm
    class JobReportForm(ReportForm):
        user = request.user
        date = date
        
    form = JobReportForm()
    if request.GET:
        form.get_day_times(date)
    else:
        form = JobReportForm(request.POST.copy())
        if form.is_valid():
            form.save()
        
    extra_context = {
        'form' : form,
        'date' : date,
        }
        
    return mako_loader.render_response(
        request,template_name='timereport/report_day_form_update.mako',
        dictionary=extra_context)

@login_required
def object_detail(request, model, object_id):
    #import pdb; pdb.set_trace()
    extra_context = {}
    if model == 'timetableprofile':
        extra_context = {
            'days':  get_day_details(object_id),
            'names' : get_week_day_names(),
            }

    if model == 'iter':
        import time_display 

        queryset = Transit.cron_objects.filter(iter=object_id)
    
        T , Days, Users, Totals, PeriodTotals = time_display.get_transits(
            filter={}, queryset = queryset)

        extra_context = {'T' : T, 'Days' : Days, 'Users' : Users,
                           'user_precedence' : 'user_precedence' in vars(),
                           'Totals' : Totals, 'PeriodTotals': PeriodTotals}

       
    return generic.object_detail(request, model, object_id, extra_context=extra_context)

@login_required
def report_day_detail(request, user_id, date):
    #import pdb; pdb.set_trace()
    from jungle.template import mako_loader
    info = get_day_info(user_id, date)
    extra_context = {
        'info' : info,
        'user' : User.objects.get(pk=user_id),
        'day'  : date.strip('/'),
        'total' : get_total(info)
        }
    return mako_loader.render_response(request,
                                       template_name='timereport/report_day.mako',
                                       dictionary=extra_context)

def get_total(info):
    tot = decimal.Decimal(0)
    for i in info:
        tot += i.hours()
    return tot

def get_day_info(user_id, date):
    Y, m, d = date.strip('/').split('/')
    qs = Report.objects.filter(user=user_id,
                               date=datetime.date(int(Y),int(m),int(d)))
        
    return qs.select_related()
    

def get_week_day_names():
    dd = WeekDay.objects.all().order_by('isoweekday')
    names = {}
    for i in dd:
        names[i.isoweekday] = i.name
    return names
    
#def employee_view(request, period, employee):

def cvs_report(T, Days, Users, Totals, PeriodTotals, mode=None):
    # Create the HttpResponse object with the appropriate CSV header.
    import csv
    from report import create_report
    
    response = HttpResponse(mimetype='text/csv')
#    response = HttpResponse(mimetype='text/plain')
    response['Content-Disposition'] = 'attachment; filename=timereport_%s.csv' %mode

    writer = csv.writer(response, delimiter=";", quoting=csv.QUOTE_ALL)
    create_report(writer, T, Days, Users, Totals, PeriodTotals, mode=mode)

    return response

@login_required
def db_report(request, T, Days, Users, Totals, PeriodTotals, mode=None):
    from report import create_report
    
    response = HttpResponse(mimetype='text/csv')
    response['Content-Disposition'] = 'attachment; filename=timereport_%s.csv' %mode
    msg = create_report(None, T, Days, Users, Totals, PeriodTotals, mode=mode)
    request.user.message_set.create(message=msg)
    return response
#    return HttpResponseRedirect('/timereport/report/list/')


def is_accreditated(user):
    return True

@login_required
def approve(request, level=None, object_id=None):

    from django.conf import settings

    can_do = False
    ## sanity check
    if request.user.is_staff:
        can_do = True
    elif level == '2':
        request.user.message_set.create(
            message=_("You don't have rights to approve at level 2") )
    else:
        if is_accreditated(request.user):
            can_do = True

    if can_do:
        import datetime
        i = Iter.objects.get(id=object_id)
        setattr(i, "approved%s_by" % level, request.user)
        setattr(i, "date_approved%s" % level, datetime.date.today())
        i.save()
        for t in i.transit_set.all():
            t.approved = level
            t.save()

        ## now let us send an e-mail to the guy
        if level == '1':
            VACATION_MSG = getattr(settings, 'TIMEREPORT_VACATION1_MSG', '')
            if VACATION_MSG:
                i.user.email_user(_('vacation request'), VACATION_MSG, )
            
        if level == '2':
            VACATION_MSG = getattr(settings, 'TIMEREPORT_VACATION2_MSG', '')
            if VACATION_MSG:
                i.user.email_user(_('Vacation request'),VACATION_MSG, )
                                    
    return HttpResponseRedirect(
        '%stimereport/iter/%s/' % (settings.LOCATION, object_id) )


@login_required
def join(request, model):
    from report_form import JoinReportForm
    kw = {
        'template_name' : 'timereport/join_form.mako',
        'post_save_redirect' : settings.LOCATION + 'timereport/report/join/',
        }
    class Join(JoinReportForm):
        user = request.user

    return generic.create_object(request, model, form=Join, **kw)

def add_transit_via_form(request, model='transit', **kw):
    from jungle.timereport.transit_basic_form import TransitBasicForm
    form = TransitBasicForm

    kw['template_name'] = 'timereport/transit_form_basic.mako'

    return generic.create_object(request, model, form=form, **kw)
