from django.db import connection


def get_records(sql, params=None, def_str=''):
    """execute a generic SQL and return a class whose attributes are
    the retrieved fields"""
    
    if not params: params = []
    cursor = connection.cursor()
    cursor.execute(sql, params)
    records = []
    class Record(object): 
        def __str__(self):
            if def_str:
                return def_str % vars(self)
            else:
                return super(Record, self).__str__()
        __repr__ = __str__
        

    for record in cursor.fetchall():
        record_instance = Record()
        k = 0
        for field in cursor.description:
            setattr(record_instance, field[0], record[k])
            k += 1
        records += [record_instance]
    return records
