import os, smtplib
from email.MIMEMultipart import MIMEMultipart
from email.MIMEBase import MIMEBase
from email.MIMEText import MIMEText
from email.Utils import COMMASPACE, formatdate
from email import Encoders



def send_mail(sender, to, subject, text, files=[], server="localhost"):
    """ send an e-mail with possible attach
    sender: must be a list or a string of recipient separated by comma
    files:  must be a list or a string (possibly empty) with comma to separate
    """
    
    try:
        assert isinstance(to, (list, set, frozenset, tuple))
    except:
        to = to.split(',')

    try:
        assert isinstance(files, (list, set, frozenset, tuple))
    except:
        files = [files]

    msg = MIMEMultipart()
    msg['From'] = sender
    msg['To'] = COMMASPACE.join(to)
    msg['Date'] = formatdate(localtime=True)
    msg['Subject'] = subject
    # if a confirm is needed: but how does this work?
    #msg['Disposition-Notification-To'] = sender

    msg.attach( MIMEText(text) )

    for file in files:
        part = MIMEBase('application', "octet-stream")
        part.set_payload( open(file,"rb").read() )
        Encoders.encode_base64(part)
        part.add_header('Content-Disposition', 'attachment; filename="%s"'
                       % os.path.basename(file))
        msg.attach(part)

    smtp = smtplib.SMTP(server)
    smtp.sendmail(sender, to, msg.as_string() )
    smtp.close()


if __name__ == '__main__':

    smtp_server = 'localhost'
    sender = 'Test <test@e-den.it'
    recipient = ['sandro',]
    recipient = 'sandro'
    subj = "Prova attach #2"
    corpo = "Cordiali Saluti \n\n Mittente"
    pathname = os.getcwd()
    #attach_file = pathname+"\\"+filename+".pdf"
    attach_file = '/tmp/ls.pdf'
    sendMail(sender, recipient, subj, corpo, [attach_file], smtp_server)
