d_venti = {
         1 : 'uno',
         2 : 'due',
         3 : 'tre',
         4 : 'quattro',
         5 : 'cinque',
         6 : 'sei',
         7 : 'sette',
         8 : 'otto',
         9 : 'nove',
         10 : 'dieci',
         11 : 'undici',
         12 : 'dodici',
         13 : 'tredici',
         14 : 'quattordici',
         15 : 'quindici',
         16 : 'sedici',
         17 : 'diciassette',
         18 : 'diciotto',
         19 : 'diciannove'}

d_cento = {20 : 'venti',
           30 : 'trenta',
           40 : 'quaranta',
           50 : 'cinquanta',
           60 : 'sessanta',
           70 : 'settanta',
           80 : 'ottanta',
           90 : 'novanta'}

def number_to_text_ricorsiva(numero): 
    if numero == 0:
        return ""
    
    if numero <= 19:  
        return d_venti[numero]
    
    elif numero <= 99:
        p_intera = d_cento[int(numero / 10) * 10]
        n1 = numero % 10
        if n1 == 1 or n1 == 8:
            p_intera = p_intera[:-1]
        p_decimale = number_to_text_ricorsiva(n1)
        
        return "%s%s" % (p_intera, p_decimale)
    
    elif numero <= 199:
        return "cento%s" % number_to_text_ricorsiva(numero % 100)
    
    elif numero <= 999:
        return "%scento%s" % (number_to_text_ricorsiva(int(numero) / 100),
                              number_to_text_ricorsiva(numero % 100))
    
    elif numero <= 1999:
        return "mille%s" % number_to_text_ricorsiva(numero % 1000)
    
    elif numero <= 999999:
        return "%smila%s" % (number_to_text_ricorsiva(int(numero) / 1000),
                             number_to_text_ricorsiva(numero % 1000))

    elif numero <= 1999999:
        return "unmilione%s" % number_to_text_ricorsiva(numero % 1000000)
    
    elif numero <= 999999999:
        return "%smilioni%s" % (number_to_text_ricorsiva(int(numero) / 1000000), 
                                number_to_text_ricorsiva(numero % 1000000))
    
    elif numero <= 1999999999:
        return "unmiliardo%s" % number_to_text_ricorsiva(numero % 1000000000)
    
    else:
        return "%smiliardi%s" % (number_to_text_ricorsiva(int(numero) / 1000000000), 
                                 number_to_text_ricorsiva(numero % 1000000000))
        
        
def number_to_text(numero):
    numero = round(numero, 2)

    p_intera = int(numero)
    p_decimale = int(numero * 100 - p_intera * 100)
    
    if p_intera == 0:
        p_intera = "zero"
    else:
        p_intera = number_to_text_ricorsiva(p_intera)
    
    if p_decimale == 0:
        p_decimale = '00'
    if p_decimale < 10:
        p_decimale = '0%s' % p_decimale
    
    return "%s/%s" % (p_intera, p_decimale)