"""this middleware akes the user from a request and places it into a
threadlocal, so it can be retrieved in other contests

Stolen from a mail to django usergroup by Luke Plant - 17.6.2006
"""
#### myproject/middleware/threadlocals.py

try:
    from threading import local
except ImportError:
    # Python 2.3 compatibility
    from django.utils._threading_local import local

_thread_locals = local()

def get_request():
    return getattr(_thread_locals, 'request', None)

def get_current_user():
    user =  getattr(_thread_locals, 'user',  None)
    if user:
        return user
    else:
        from django.conf import settings
        return getattr(settings, 'INTERACTIVE_USER', None)
                   

class ThreadLocals(object):
    """Middleware that gets various objects from the
    request object and saves them in thread local storage."""
    def process_request(self, request):
        _thread_locals.request = request
        _thread_locals.user = getattr(request, 'user', None)

