#!/usr/bin/python

"""
  usage: %prog [options] file.css
    -d, --dir=dir: save new file in directory 'dir'. the name will be preserved
"""

import re, os, sys
from jungle.scripts import optionparse

opts, files = optionparse.parse(__doc__)

def ext_sub_dot(m):
    name = m.group(2).replace('.','/')
    return '<%%inherit file="%s.mako"/>' % re.sub('[^/]+/', '',name)

def dollar(m):
    txt = m.group(1)
    if not re.search('\)',txt):
        line = txt.split()
        var = re.sub('([a-zA-Z_.]+)(.*)', r'\1}\2', line[0])
        return "${%s %s" % (var, "".join(line[1:]))
    else:
        txt = re.sub('^(.*)\)', r'\1)}', txt)
        return "${%s" % txt.replace('$','')
    #return "${%s}" % m.group(1).replace('$','')

IMPORT = '<%namespace name="jungle" module="jungle.templatetags" import="*" />\n'
def c2m(f):
    
    fid = open(f)
    mako_name = f.replace('.tmpl', '.mako')
    mid = open(mako_name, 'w')
    #mid.write(IMPORT)
    for line in fid:
        line = re.sub('#((if|for).*)',       r'% \1:', line)   #note ':'
        line = re.sub('#(else)',             r'% \1:', line)   #note ':'
        line = re.sub('(.*)#(set)(.*)',             r'\1<% \3 %>', line)   #note ':'
        line = re.sub('#((end) (if|for))',   r'% \2\3', line)

        if re.search('%',line): 
            line = line.replace('$', '')

        ##i vars
        line = re.sub('\$(.*)', dollar, line)
        ## def
        line = re.sub('(#def (\S+)\s*:)(.*)', r'<%def name="\2()">\3</%def>', line)
        line = re.sub('(#def (\S+))', r'<%def name="\2()">', line)
        line = re.sub('(#end def (\S+))', r'</%def>', line)
        #import jungle.templatetags.jungle_tags as jt
        if re.match('#(from|import)', line):
            continue
        line = re.sub('(#extends (.+))', ext_sub_dot, line)
        line = line.replace('ch.','jun.')
        line = line.replace('jt.','jun.')
        line = line.replace('filters.','dj.')
        line = line.replace('object','obj')
        line = line.replace('::',':')

        mid.write(line)

    mid.close()
    mid = open(mako_name)
    print mid.read()

for f in files:
    c2m(f)


# if __name__ == '__main__':
#     name = 'simple.tmpl'
#     f = open(name)
#     print f.read()
#     c2m(name)

