"""handle attach files
"""

from jungle.file.models import File
from django.contrib.contenttypes.models import ContentType


def get_files_for_obj(obj):
    """return a list of files that are related to this obj"""
    package = obj._meta.app_label
    module  = obj._meta.module_name
    
    content_type = ContentType.objects.get(app_label__exact=package,model__exact=module)
    
    kwargs = {
        'object_id__exact': obj.id,
        'content_type': content_type,
        #'content_type__model__exact': module,
        #'site__id__exact': settings.SITE_ID,
        }
    
    return File.objects.filter(**kwargs) # File.objects.filter(**kwargs)

    
