from django.template import  defaultfilters as filters
from jungle.templatetags.jungle_tags import ReST
from jungle.templatetags.jungle_tags import ugettext as _
from jungle.template import mako_loader as loader
import sys

def ch_test(i=5):
    return "<br>\n".join(sys.path[0:i])


def attach_file_form(obj, path):
    from django.contrib.contenttypes.models import ContentType

    from django.conf import settings
    #import pdb
    #pdb.set_trace()

    package = obj._meta.app_label
    module  = obj._meta.module_name
    content_type = ContentType.objects.get(
        app_label__exact=package,model__exact=module)

    data = {
        'LOCATION'     : settings.LOCATION,
        'content_type' : content_type.id,
        'obj_id'       : obj.id,
        'path'         : path,
        }

    txt = """
       <form action="%(LOCATION)sfile/file/add/" method="post" enctype="multipart/form-data">\n
         <fieldset>\n
           <legend>Allega File</legend>\n
           <table>
           <tr><td><label for="id_title">Titolo</label></td> <td colspan="1"><input id="id_title" type="text" name="title" /></td>\n
           <tr><td><label for="id_notes">Note</label></td> <td colspan="1"><textarea id="id_notes" name="notes"></textarea></td>\n
           <tr><td><label for="id_file">File</label></td> <td colspan="1"><input id="id_file" type="file" name="file_obj" size="40" /></td>\n
           </table>
           <input type="hidden" name="content_type" value="%(content_type)s" />\n
           <input type="hidden" name="status" value="0" />\n
           <input type="hidden" name="object_id" value="%(obj_id)s" />\n
           <input type="hidden" name="post_save_redirect" value="%(path)s" />\n
           <input type="submit" class="submit" value="Invia" name="invia" />\n
         </fieldset>
       </form>\n
    """ % data

    return txt


def comments_popup_link(obj, url=None, left_icon=False):
    """return an url to popup a comment window
    url: if not given will popup a standard comment url:
         /comment/freecomment/add/id/content_type
         if overwritten can contail %s that will be substituted by
         id and content_type
    """

    from django.contrib.contenttypes.models import ContentType
    from django.conf import settings

    package = obj._meta.app_label
    module  = obj._meta.module_name
    content_type = ContentType.objects.get(
        app_label__exact=package,model__exact=module)

    url = url or '/comments/freecomment/add/%s/%s/' 
    URL = url % (obj.id, content_type.id)

    opts = 'top=200, left=200, width=600, height=400, status=no, ' + \
          'menubar=no, toolbar=no, scrollbars=no'
    img = '/static/img/icon_addlink.gif'

    str_href = """<a href="" onclick="javascript:window.open('%(URL)s', '', '%(opts)s');
         return false;">""" % dict(URL=URL, opts=opts)
    str_txt = "Aggiungi un commento"
    str_icon = """<img src="%(img)s" alt="Aggiungi un commento">""" % dict(img=img)
    
    if left_icon:
        txt = "%s\n%s %s\n</a>" % (str_href, str_icon, str_txt)
    else:
        txt = "%s\n%s %s\n</a>" % (str_href, str_txt, str_icon)

    return txt

def popup_link(url, txt='', icon=None, top=200, left=200, width=480, height=320, status='no', menubar='no',
               toolbar='no', scrollbars='yes'):
    """creates a link that pops a window.
    icon may be add|del or the name of an icon
    txt will be place before the icon
    popup_link('/my/link/?a=b')
    """
    if icon:
        if icon  == 'add':
            icon_txt = '<img src="/static/img/icon_addlink.gif">'
        elif icon == 'del':
            icon_txt = '<img src="/static/img/icon_deletelink.gif">'
        elif icon == 'edit':
            icon_txt = '<img src="/static/img/icon_changelink.gif">'
        else:
            icon_txt = '<img src="%s">' % icon
    else:
        icon_txt = ''
        
        
    info = {
        'top' : top,
        'left' : left,
        'width' : width,
        'height' : height,
        'status' : status,
        'menubar' : menubar,
        'toolbar' : toolbar,
        'scrollbars' : scrollbars,
        }
    opts = 'top=%(top)s, left=%(left)s, width=%(width)s, height=%(height)s, status=%(status)s, menubar=%(menubar)s, toolbar=%(toolbar)s, scrollbars=%(scrollbars)s'
    data = {
        'url': url,
        'opts': opts % info,
        'txt': txt,
        'icon_txt': icon_txt,
        }

    txt = """<a href="" onclick="javascript:window.open('%(url)s', '', '%(opts)s');return false;"> 
       %(txt)s %(icon_txt)s</a> """ % data

    return txt

def get_comments(obj, mode='html'):
    from django.contrib.contenttypes.models import ContentType
    from django.contrib.comments.models import FreeComment
    from django.contrib.auth.models import User

    package = obj._meta.app_label
    module  = obj._meta.module_name
    content_type = ContentType.objects.get(
    app_label__exact=package,model__exact=module)
    
    comments = FreeComment.objects.filter(content_type__id__exact = content_type.id,
                                          object_id__exact = obj.id).order_by('submit_date')

    return comments
    

def show_comments(obj=None, comments=None, mode='html'):
    if not comments:
        comments = get_comments(obj, mode=mode)
        
    if mode == 'list':
        return comments
    
    txt = []
    t = loader.get_template('comments/comment_detail.mako')
    for c in comments:
        txt += [t.render([{'obj' : c}])]
        
    return u'\n'.join(txt)

def expander_div(id, label, display='block'):
    char_opened = '&#x25bc;'
    char_closed = '&#x25b6;'
    
    if display == 'block':
        char      = char_opened
        class_def = ''
    else:
        char      = char_closed
        class_def = ' class="hide"'
    txt = """<a href="" onclick="return varToggle(this, '%s')"><span>%s</span> %s</a>""" % (id, char, label)
    txt += '\n<div id="%s"%s>' % (id, class_def)

    return txt

STYLE = """
  position: fixed;
  z-index: 1;
  left:1px;
  top:1px;
  background-color:#FAFAFA;
  border:1px solid darkgray;'
"""

def popup_div(id, label):
    txt = """<a href="" onclick="return popup('%s')">%s</a>\n
    <div id="%s" style="%s" class="hide">\n
    <a href="" onclick="return toggle('%s')" >Chiudi <img src="/static/img/icon_deletelink.gif" alt="Chiudi"></a>""" % (id, label, id, STYLE, id)

    return txt

def TH(fields, order_by='', classes='', row_tag=True):
    """return a row with TH
    
    In case the column name is preceded by a +sign, the header becomes a link
    to allow sorting of that column

    in case the field is a tuple, it can be 2 or 3 items:

      1. is the column name (in the db)
      2. is the string to be used in order_by syntax
      3. is a text to be shown
      
    $tags.header(['colA', ('colB', 'colB', 'TEXT'), '+colC', ('+colD', 'Colonna__b')], classes="myclass")
    """

    if classes:
        class_def =  classes
    else:
        class_def = ''
        
    txt = []
    for f in fields:
        if isinstance(f, str) or isinstance(f, unicode):
            f, cond = f, f.lstrip('+')
            text = f
        else:
            ### a possible 3rd arg is a string to be used
            try:
                f, cond, text = f
            except:
                f, cond = f
                text = f
                
        cond_desc = '-%s' % cond
        if order_by != cond:
            button = """<a href="#" onclick="order_by('%s');"><img src="/static/img/arrow-up.gif" alt="Asc Ord" /></a>"""    % cond
        else:
            button = ''
        if order_by != cond_desc:
            button_desc = """<a href="#" onclick="order_by('%s');"><img src="/static/img/arrow-down.gif" alt="Desc Ord" /></a>""" % cond_desc
        else:
            button_desc = ''
            
        if text.startswith('+'):
            text = text.lstrip('+')
            text = """%s %s %s""" % (button, _(text.replace('_', ' ').capitalize()), button_desc)
            
        txt += "\n    <th%s> %s </th>" % (' class="%s"' % class_def, text)

    if row_tag:
        return "<tr>\n  %s\n</tr>" % "".join(txt)
    else:
        return "%s" % "".join(txt)

                                  

def get_account_for(domain):
    ret = domain.account_set.all().order_by('account')
    return ret


if __name__ == '__main__':
    print TH(['uno', 'due', '+tre'], classes='a b')
    print TH(['uno', 'due', '+tre'])

def get_parent_template(context, template='/base.mako'):
    """
    Look in request GET if the null template has been requested, in case return that template
    otherwise return the deatult  template that can be also defined in templates

    This function uses dynamic inheritance of mako templates to get a response
    from the server that is suitable to be loaded in ajax $('#id').load()
    """

    request = context.get('request')
    nt =  request.GET.get('nt')
    if isinstance(nt, basestring):
        nt = int(nt)
    if nt:
        template =  '/null.mako' 

    return template
    
    
