from django import template
from datetime import *
from mako_tags import *
#from django.newforms.util import smart_unicode
from django.utils.translation import ugettext, ugettext_lazy
from django.utils.encoding import smart_unicode
from django.conf import settings
from django.utils.translation import gettext, gettext_lazy
from django.template import defaultfilters as dj
from navigators import page_navigator, simple_page_navigator, fancy_page_navigator
from title_nav import title_navigator, application, add, search, stampa, help, export

register = template.Library()
try:
    from rst import ReST
except:
    pass

# def smart_unicode(s):
#     """this was previous version of django, and definitely returns an unicode
#     object, while new version tries to keep __proxy__ if it is one.
#     """
#     if not isinstance(s, basestring):
#         if hasattr(s, '__unicode__'):
#             s = unicode(s)
#         else:
#             s = unicode(str(s), settings.DEFAULT_CHARSET)
#     elif not isinstance(s, unicode):
#         s = unicode(s, settings.DEFAULT_CHARSET)
#     return s

# def ugettext(text):
#     return smart_unicode(gettext(text))

# def ugettext_lazy(text):
#     return smart_unicode(gettext_lazy(text))

@register.filter
def stars3(n):
    if n is None:
        return ''
    stars = []
    for i in range(n):
        stars.append("""<img src="static/images/star.gif">""")
    return "".join(stars)

@register.filter
def pages_links(context, mode='normal'):
    "create links to all available pages"

    if not context.get('is_paginated'):
        #return u'<div style="margin-top:10px;">Non paginata</div>'
        return u''
    
    if context.get('pages') is None:
        return u''
    page = context.get('page')
    links = []
    for i in range(1, context.get('pages')+1):
        if i == page:
            #links += u" (%s) " % i
            links += u" - " 
        else:
            links += u'''<a href="#" onclick="page('%s');">%s </a>''' %  (i,i)

    return u'<div style="margin-top:10px;">Vai alla pagina ' + ''.join(links) + '</div>'

@register.filter
def doc_menu_from_path(path, prefix=''):
    """create link to all steps of the path. If prefix is not null
    will be used"""
    path = path.strip('/')
    A = []
    elements = path.split('/')
    href = prefix
    for el in elements:
        href = "%s/%s" % (href, el)
        A += ['<a href="%s">%s</a>' % (href, el)]

    #print "path:", path, " -> ".join(A)
    return " -> ".join(A)

@register.tag
def current_time(parser, token):
    try:
        # split_contents() knows not to split quoted strings.
        tag_name, format_string = token.split_contents()
    except ValueError:
        raise template.TemplateSyntaxError, "%r tag requires a single argument" % token.contents[0]
    if not (format_string[0] == format_string[-1] and format_string[0] in ('"', "'")):
        raise template.TemplateSyntaxError, "%r tag's argument should be in quotes" % tag_name
    return CurrentTimeNode(format_string[1:-1])


class CurrentTimeNode(template.Node):
    def __init__(self, format_string):
        self.format_string = format_string
    def render(self, context):
        return "OKY! " % datetime.now().strftime(self.format_string)

@register.simple_tag
def what_is_it(token):
    if isinstance(token, (str, unicode) ):
        return "%s is a string" % token
    if isinstance(token, int ):
        return "%s is a integer" % token
    if isinstance(token, date ):
        return "%s is a datte" % token


@register.simple_tag
def show_form_errors(form):
    """create a list of all the errors of the form

    Usage::

       {% show_form_errors form %}

    """
    txt = []
    

    from django import newforms
    if isinstance(form, newforms.forms.BaseForm):
        errors = form.errors       # newforms
    else:
        #import pdb; pdb.set_trace()
        errors = form.error_dict   # oldforms
 
    if not errors:
        return ''

    txt += ['<div class="errors">', '<h2>Errori</h2>', '<ul>']
    if '__all__' in errors:
        txt += ["<li>%s</li>" % errors.pop('__all__')]
        
    for key,val in errors.iteritems():
        Key = ugettext(key.replace('_',' ').capitalize())
        #txt += [u'<li>%s: %s</li>' % (Key,
        #                              smart_unicode(",".join(val)))]
        #import pdb
        #pdb.set_trace()
        txt += [u'<li>%s: %s</li>' % (Key,val)]


    ret = "\n".join(txt) + "</ul></div>"
    return ret

def offset_txt(txt, amount=4, space=" "):
    import re
    ## offset text to get a prettier output
    p = re.compile("^", re.MULTILINE)
    return p.sub(space * amount, txt)
    
    
def smart_uni(text):
    if isinstance(text, date):
        return smart_unicode(dj.date(text))
    elif isinstance(text, time):
        return smart_unicode(dj.time(text))
    elif isinstance(text, unicode):
        return text
    else:
        return smart_unicode(text)

def host_url():
    """return the host part to compose the URL that is being used"""

    return getattr(settings, 'HOST_URL', '')
        
def display_messages(messages):
    if not messages:
        return ''

    msg_list = ['<li>%s</li>' % m for m in messages]
    return '<div ><ul class="messagelist">' + ''.join(msg_list) + '</ul></div>'


