################################
# Dizionari default per il menu
# del titolo, vengono importati
# direttamente dal mako com jun
application = {'title': 'APPLICAZIONE'}
add = {
        'alt':      'Add',
        'word':     'Insert',
        'title':    'ADD',
        'url':      '',
        'event':    '',
        'popup':    'true',
        'img':      '/static/img/insert.gif'
}
stampa = {
        'alt':      'Print',
        'word':     'Print',
        'title':    'PRINT',
        'url':      '#',
        'event':    'onclick=\"javascript:window.print();return false;\"',
        'popup':    '',
        'img':      '/static/img/print.gif'
}
export = {
        'alt':      'Export',
        'word':     'Export',
        'title':    'EXP',
        'url':      '#',
        'event':    '',
        'popup':    '',
        'img':      '/static/img/export.gif'
}
help = {
        'alt':      'Help',
        'word':     'Help',
        'title':    'HELP',
        'url':      '',
        'event':    '',
        'popup':    'true',
        'img':      '/static/img/help.gif'
}
search = {
        'alt':      'Search',
        'word':     'Search',
        'title':    'SEARCH',
        'url':      '#',
        'event':    'onclick=\"new Effect.toggle(\'navigation_filter\',\'appear\'); return false;\"',
        'img':      '/static/img/search.gif'
}
################################

APPL_TITLE = u"""
    <table class="title_nav">
        <tbody>
        <tr>
            <td width="100%%">
                <h1>%s</h1>
            </td>
            <td style="padding-top: 3px; padding-left: 5px;" align="right" nowrap="nowrap" valign="top">%s</td>
        </tr>
    </tbody>
   </table>
"""

ICON = u"""
    <a href="%s" %s> <img src="%s" alt="%s" title="%s"> %s </a> 
"""

ATTR_LIST = ('add', 'stampa', 'export', 'help', 'search')

def title_navigator(application, **kw):
    return TitleNavigator(application, **kw).render()

class TitleNavigator(object):
    def __init__(self, application, **kw):
        self.application = application
        for arg in ATTR_LIST:
            if arg in kw:
                setattr(self, arg, kw[arg])

    def get_link(self):
        txt = []
        for attr in ATTR_LIST:
            if hasattr(self, attr):
                x = getattr(self, attr)
                if len(x.keys()) > 0:
                    txt.append(ICON % (x['url'], x['event'], x['img'], x['alt'], x['title'], x['word']))
        return '\n'.join(txt)

    def render(self):
        return APPL_TITLE % (self.application['title'], self.get_link())

if __name__ == '__main__':
    application = {'title': 'AMBIENTI'}
    add = {
        'alt':      'Add',
        'word':     'Insert',
        'title':    'ADD',
        'url':      '/domotics/ambient/add/',
        'event':    '',
        'popup':    'true',
        'img':      '/static/img/insert.gif'
    }
    stampa = {
        'alt':      'Print',
        'word':     'Print',
        'title':    'PRINT',
        'url':      '#',
        'event':    '',
        'popup':    '',
        'img':      '/static/img/print.gif'
    }
    export = {
        'alt':      'Export',
        'word':     'Export',
        'title':    'EXP',
        'url':      '#',
        'event':    '',
        'popup':    '',
        'img':      '/static/img/export.gif'
    }
    help = {
        'alt':      'Help',
        'word':     'Help',
        'title':    'HELP',
        'url':      '/help/domotics/ambient/',
        'event':    '',
        'popup':    'true',
        'img':      '/static/img/help.gif'
    }
    search = {
        'alt':      'Search',
        'word':     'Search',
        'title':    'SEARCH',
        'url':      '#',
        'event':    'onclick=\"new Effect.toggle(\'fast_search_div\',\'\'); return false;\"',
        'img':      '/static/img/search.gif'
    }
    print '#########################'
    print '# TITLE NAVIGATOR       #'
    print '#########################'
    print title_navigator(application, add=add, stampa=stampa, export=export, help=help, search=search)
