from django.contrib.auth.decorators import user_passes_test
from django.conf import settings

try:
    LOGIN_URL = settings.LOGIN_URL
except AttributeError:
    from django.contrib.auth import LOGIN_URL
    
login_required = user_passes_test(lambda u: u.is_authenticated(),
                                  login_url=LOGIN_URL)
login_required.__doc__ = (
    """
    Decorator for views that checks that the user is logged in, redirecting
    to the log-in page if necessary.
    This reads LOGIN_URL in settigs.py and fallbaks to contrib.auth
    """
    )

