from django.conf import settings
from jungle.views.decorators import login_required
from jungle.templatetags.fast_search import fast_search

#def search(request, model, order_by=None, view=None, **kw):
#    
#    #print "views/fast_search"
#    object_list = dyn_import(model, 'views', view or 'object_list')
#
#    if request.method == 'GET':
#        data = request.GET.copy()
#
#	FSlay = fast_search(model, data=data, name='fast_search',
#                           render=False, user=request.user, order_by=order_by)
#        FSlay.parse_fieldsets()
#             
#        filter_cnd = FSlay.search()
#
#        order_by = data['order_by']
#
#        return object_list(request, model, filter_cnd,
#                           order_by, form=FSlay.form, **kw)

def search2(request, model, order_by=None, extra_filter=None, template_name=None, **kw):
    
    if request.method == 'GET':
        data = request.GET.copy()

        if extra_filter:
            data.update(extra_filter)
            
        if 'extra_context' in kw:
            data.update(kw['extra_context'])
        if 'order_by' in data:
            order_by = data['order_by']

        try:
# in mako templates the model name is in the format: <app_label>.<model_name>
            app_label, model = model.split('.')
        except:
            path = request.META['PATH_INFO']
            path = path.replace(settings.LOCATION, '', 1)
            url_pieces = path.split('/')
            app_label  = url_pieces[0]
            model = model or url_pieces[1]

        if 'app_label' in kw:
            app_label = kw['app_label']
            del kw['app_label']

        FSlay = fast_search(model, app_label=app_label, data=data, name='fast_search',
                           render=False, request=request, user=request.user, 
                           template_name=template_name, order_by=order_by)
        FSlay.parse_fieldsets()
             
        filter_cnd = FSlay.search()
        #print "FILTER_CND", filter_cnd, 'ORDER_BY', order_by
        form = FSlay.form

        return (filter_cnd, order_by, form)
